/*
dderror.cpp
directdraw errors ...

Copyright (C) 1995-2005  Everett Bell

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include <windows.h>
#include <ddraw.h>

#include "globals.h"





void TRACE( char *where, char *message )
{
	lpDD4->FlipToGDISurface();
	MessageBox( hwndmain, message, where, MB_OK );

TIMESTAMP;
sprintf( debugstr, "%s -- %s", message, where );
WRITETODEBUGFILE;

} // end TRACE


void ShowDDError( char *where, HRESULT hErr )
{       
	char localtempstr[1024];

    switch (hErr)
    {
        case DDERR_ALREADYINITIALIZED:
                TRACE( where, "DDERR_ALREADYINITIALIZED"); break;
        case DDERR_CANNOTATTACHSURFACE:
                TRACE( where, "DDERR_CANNOTATTACHSURFACE"); break;
        case DDERR_CANNOTDETACHSURFACE:
                TRACE( where, "DDERR_CANNOTDETACHSURFACE"); break;
        case DDERR_CURRENTLYNOTAVAIL:
                TRACE( where, "DDERR_CURRENTLYNOTAVAIL"); break;
        case DDERR_EXCEPTION:
                TRACE( where, "DDERR_EXCEPTION"); break;
        case DDERR_GENERIC:
                TRACE( where, "DDERR_GENERIC"); break;
        case DDERR_HEIGHTALIGN:
                TRACE( where, "DDERR_HEIGHTALIGN"); break;
        case DDERR_INCOMPATIBLEPRIMARY:
                TRACE( where, "DDERR_INCOMPATIBLEPRIMARY"); break;
        case DDERR_INVALIDCAPS:
                TRACE( where, "DDERR_INVALIDCAPS"); break;
        case DDERR_INVALIDCLIPLIST:
                TRACE( where, "DDERR_INVALIDCLIPLIST"); break;
        case DDERR_INVALIDMODE:
                TRACE( where, "DDERR_INVALIDMODE"); break;
        case DDERR_INVALIDOBJECT:
                TRACE( where, "DDERR_INVALIDOBJECT"); break;
        case DDERR_INVALIDPARAMS:
                TRACE( where, "DDERR_INVALIDPARAMS"); break;
        case DDERR_INVALIDPIXELFORMAT:
                TRACE( where, "DDERR_INVALIDPIXELFORMAT"); break;
        case DDERR_INVALIDRECT:
                TRACE( where, "DDERR_INVALIDRECT"); break;
        case DDERR_LOCKEDSURFACES:
                TRACE( where, "DDERR_LOCKEDSURFACES"); break;
        case DDERR_NO3D:
                TRACE( where, "DDERR_NO3D"); break;
        case DDERR_NOALPHAHW:
                TRACE( where, "DDERR_NOALPHAHW"); break;
        case DDERR_NOCLIPLIST:
                TRACE( where, "DDERR_NOCLIPLIST"); break;
        case DDERR_NOCOLORCONVHW:
                TRACE( where, "DDERR_NOCOLORCONVHW"); break;
        case DDERR_NOCOOPERATIVELEVELSET:
                TRACE( where, "DDERR_NOCOOPERATIVELEVELSET"); break;
        case DDERR_NOCOLORKEY:
                TRACE( where, "DDERR_NOCOLORKEY"); break;
        case DDERR_NOCOLORKEYHW:
                TRACE( where, "DDERR_NOCOLORKEYHW"); break;
        case DDERR_NODIRECTDRAWSUPPORT:
                TRACE( where, "DDERR_NODIRECTDRAWSUPPORT"); break;
        case DDERR_NOEXCLUSIVEMODE:
                TRACE( where, "DDERR_NOEXCLUSIVEMODE"); break;
        case DDERR_NOFLIPHW:
                TRACE( where, "DDERR_NOFLIPHW"); break;
        case DDERR_NOGDI:
                TRACE( where, "DDERR_NOGDI"); break;
        case DDERR_NOMIRRORHW:
                TRACE( where, "DDERR_NOMIRRORHW"); break;
        case DDERR_NOTFOUND:
                TRACE( where, "DDERR_NOTFOUND"); break;
        case DDERR_NOOVERLAYHW:
                TRACE( where, "DDERR_NOOVERLAYHW"); break;
        case DDERR_NORASTEROPHW:
                TRACE( where, "DDERR_NORASTEROPHW"); break;
        case DDERR_NOROTATIONHW:
                TRACE( where, "DDERR_NOROTATIONHW"); break;
        case DDERR_NOSTRETCHHW:
                TRACE( where, "DDERR_NOSTRETCHHW"); break;
        case DDERR_NOT4BITCOLOR:
                TRACE( where, "DDERR_NOT4BITCOLOR"); break;
        case DDERR_NOT4BITCOLORINDEX:
                TRACE( where, "DDERR_NOT4BITCOLORINDEX"); break;
        case DDERR_NOT8BITCOLOR:
                TRACE( where, "DDERR_NOT8BITCOLOR"); break;
        case DDERR_NOTEXTUREHW:
                TRACE( where, "DDERR_NOTEXTUREHW"); break;
        case DDERR_NOVSYNCHW:
                TRACE( where, "DDERR_NOVSYNCHW"); break;
        case DDERR_NOZBUFFERHW:
                TRACE( where, "DDERR_NOZBUFFERHW"); break;
        case DDERR_NOZOVERLAYHW:
                TRACE( where, "DDERR_NOZOVERLAYHW"); break;
        case DDERR_OUTOFCAPS:
                TRACE( where, "DDERR_OUTOFCAPS"); break;
        case DDERR_OUTOFMEMORY:
                TRACE( where, "DDERR_OUTOFMEMORY"); break;
        case DDERR_OUTOFVIDEOMEMORY:
                TRACE( where, "DDERR_OUTOFVIDEOMEMORY"); break;
        case DDERR_OVERLAYCANTCLIP:
                TRACE( where, "DDERR_OVERLAYCANTCLIP"); break;
        case DDERR_OVERLAYCOLORKEYONLYONEACTIVE:
                TRACE( where, "DDERR_OVERLAYCOLORKEYONLYONEACTIVE"); break;
        case DDERR_PALETTEBUSY:
                TRACE( where, "DDERR_PALETTEBUSY"); break;
        case DDERR_COLORKEYNOTSET:
                TRACE( where, "DDERR_COLORKEYNOTSET"); break;
        case DDERR_SURFACEALREADYATTACHED:
                TRACE( where, "DDERR_SURFACEALREADYATTACHED"); break;
        case DDERR_SURFACEALREADYDEPENDENT:
                TRACE( where, "DDERR_SURFACEALREADYDEPENDENT"); break;
        case DDERR_SURFACEBUSY:
                TRACE( where, "DDERR_SURFACEBUSY"); break;
        case DDERR_CANTLOCKSURFACE:
                TRACE( where, "DDERR_CANTLOCKSURFACE"); break;
        case DDERR_SURFACEISOBSCURED:
                TRACE( where, "DDERR_SURFACEISOBSCURED"); break;
        case DDERR_SURFACELOST:
                TRACE( where, "DDERR_SURFACELOST"); break;
        case DDERR_SURFACENOTATTACHED:
                TRACE( where, "DDERR_SURFACENOTATTACHED"); break;
        case DDERR_TOOBIGHEIGHT:
                TRACE( where, "DDERR_TOOBIGHEIGHT"); break;
        case DDERR_TOOBIGSIZE:
                TRACE( where, "DDERR_TOOBIGSIZE"); break;
        case DDERR_TOOBIGWIDTH:
                TRACE( where, "DDERR_TOOBIGWIDTH"); break;
        case DDERR_UNSUPPORTED:
                TRACE( where, "DDERR_UNSUPPORTED"); break;
        case DDERR_UNSUPPORTEDFORMAT:
                TRACE( where, "DDERR_UNSUPPORTEDFORMAT"); break;
        case DDERR_UNSUPPORTEDMASK:
                TRACE( where, "DDERR_UNSUPPORTEDMASK"); break;
        case DDERR_VERTICALBLANKINPROGRESS:
                TRACE( where, "DDERR_VERTICALBLANKINPROGRESS"); break;
        case DDERR_WASSTILLDRAWING:
                TRACE( where, "DDERR_WASSTILLDRAWING"); break;
        case DDERR_XALIGN:
                TRACE( where, "DDERR_XALIGN"); break;
        case DDERR_INVALIDDIRECTDRAWGUID:
                TRACE( where, "DDERR_INVALIDDIRECTDRAWGUID"); break;
        case DDERR_DIRECTDRAWALREADYCREATED:
                TRACE( where, "DDERR_DIRECTDRAWALREADYCREATED"); break;
        case DDERR_NODIRECTDRAWHW:
                TRACE( where, "DDERR_NODIRECTDRAWHW"); break;
        case DDERR_PRIMARYSURFACEALREADYEXISTS:
                TRACE( where, "DDERR_PRIMARYSURFACEALREADYEXISTS"); break;
        case DDERR_NOEMULATION:
                TRACE( where, "DDERR_NOEMULATION"); break;
        case DDERR_REGIONTOOSMALL:
                TRACE( where, "DDERR_REGIONTOOSMALL"); break;
        case DDERR_CLIPPERISUSINGHWND:
                TRACE( where, "DDERR_CLIPPERISUSINGHWND"); break;
        case DDERR_NOCLIPPERATTACHED:
                TRACE( where, "DDERR_NOCLIPPERATTACHED"); break;
        case DDERR_NOHWND:
                TRACE( where, "DDERR_NOHWND"); break;
        case DDERR_HWNDSUBCLASSED:
                TRACE( where, "DDERR_HWNDSUBCLASSED"); break;
        case DDERR_HWNDALREADYSET:
                TRACE( where, "DDERR_HWNDALREADYSET"); break;
        case DDERR_NOPALETTEATTACHED:
                TRACE( where, "DDERR_NOPALETTEATTACHED"); break;
        case DDERR_NOPALETTEHW:
                TRACE( where, "DDERR_NOPALETTEHW"); break;
        case DDERR_BLTFASTCANTCLIP:
                TRACE( where, "DDERR_BLTFASTCANTCLIP"); break;
        case DDERR_NOBLTHW:
                TRACE( where, "DDERR_NOBLTHW"); break;
        case DDERR_NODDROPSHW:
                TRACE( where, "DDERR_NODDROPSHW"); break;
        case DDERR_OVERLAYNOTVISIBLE:
                TRACE( where, "DDERR_OVERLAYNOTVISIBLE"); break;
        case DDERR_NOOVERLAYDEST:
                TRACE( where, "DDERR_NOOVERLAYDEST"); break;
        case DDERR_INVALIDPOSITION:
                TRACE( where, "DDERR_INVALIDPOSITION"); break;
        case DDERR_NOTAOVERLAYSURFACE:
                TRACE( where, "DDERR_NOTAOVERLAYSURFACE"); break;
        case DDERR_EXCLUSIVEMODEALREADYSET:
                TRACE( where, "DDERR_EXCLUSIVEMODEALREADYSET"); break;
        case DDERR_NOTFLIPPABLE:
                TRACE( where, "DDERR_NOTFLIPPABLE"); break;
        case DDERR_CANTDUPLICATE:
                TRACE( where, "DDERR_CANTDUPLICATE"); break;
        case DDERR_NOTLOCKED:
                TRACE( where, "DDERR_NOTLOCKED"); break;
        case DDERR_CANTCREATEDC:
                TRACE( where, "DDERR_CANTCREATEDC"); break;
        case DDERR_NODC:
                TRACE( where, "DDERR_NODC"); break;
        case DDERR_WRONGMODE:
                TRACE( where, "DDERR_WRONGMODE"); break;
        case DDERR_IMPLICITLYCREATED:
                TRACE( where, "DDERR_IMPLICITLYCREATED"); break;
        case DDERR_NOTPALETTIZED:
                TRACE( where, "DDERR_NOTPALETTIZED"); break;
        case DDERR_UNSUPPORTEDMODE:
                TRACE( where, "DDERR_UNSUPPORTEDMODE"); break;
        case DDERR_NOMIPMAPHW:
                TRACE( where, "DDERR_NOMIPMAPHW"); break;
        case DDERR_INVALIDSURFACETYPE:
                TRACE( where, "DDERR_INVALIDSURFACETYPE"); break;
        case DDERR_DCALREADYCREATED:
                TRACE( where, "DDERR_DCALREADYCREATED"); break;
        case DDERR_CANTPAGELOCK:
                TRACE( where, "DDERR_CANTPAGELOCK"); break;
        case DDERR_CANTPAGEUNLOCK:
                TRACE( where, "DDERR_CANTPAGEUNLOCK"); break;
        case DDERR_NOTPAGELOCKED:
                TRACE( where, "DDERR_NOTPAGELOCKED"); break;
        case DDERR_NOTINITIALIZED:
                TRACE( where, "DDERR_NOTINITIALIZED"); break;
        default:
				sprintf( localtempstr, "Unknown Error: 0x%.8x", hErr );
                TRACE( where, localtempstr ); break;
        }
}