/*
editors.cpp
editor functions ...

Copyright (C) 1995-2005  Everett Bell

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include "globals.h"

#include <commdlg.h>



int carmapx, carmapy;

int currpathno = 0;

byte currentrotation = 0;
byte isflipped = 0;


BOOL drawingpath = 0;

BOOL redrawmap = 0;



int drawpath( int pathno )
{
	int mapx, mapy;
	int screenx, screeny;
	int currpath;

	POSSIBLEPATH *pathptr;

	word *tempscreenptr;


	pathptr = &possiblepath[pathno];

	currpath = 0;
	mapx = pathptr->startx;
	mapy = pathptr->starty;

	LOCKVS;

	while( currpath != pathptr->pathno )
	{
		screenx = 200L + times10(mapx) + 5;
		screeny = times10(mapy) + 5;

		tempscreenptr = g_vsptr + VSOFFSET + times800(screeny) + screenx;

		switch( pathptr->path[currpath] )
		{
		case N:
			*tempscreenptr = 65535L;
			*(tempscreenptr-1) = 65535L;
			*(tempscreenptr+(SCREENWIDTH-1)) = 65535L;
			*(tempscreenptr+SCREENWIDTH) = 65535L;
			*(tempscreenptr+(SCREENWIDTH-1)+SCREENWIDTH) = 65535L;
			*(tempscreenptr+SCREENWIDTH+SCREENWIDTH) = 65535L;
			*(tempscreenptr+(SCREENWIDTH-1)+SCREENWIDTH+SCREENWIDTH) = 65535L;
			*(tempscreenptr+SCREENWIDTH+SCREENWIDTH+SCREENWIDTH) = 65535L;

			*(tempscreenptr-(SCREENWIDTH+1)) = 65535L;
			*(tempscreenptr-SCREENWIDTH) = 65535L;
			*(tempscreenptr-(SCREENWIDTH+1)-1) = 65535L;
			*(tempscreenptr-SCREENWIDTH+1) = 65535L;
			*(tempscreenptr-(SCREENWIDTH+1)-2) = 65535L;
			*(tempscreenptr-SCREENWIDTH+2) = 65535L;

			*(tempscreenptr-(SCREENWIDTH+1)-SCREENWIDTH) = 65535L;
			*(tempscreenptr-SCREENWIDTH-SCREENWIDTH) = 65535L;
			*(tempscreenptr-(SCREENWIDTH+1)-SCREENWIDTH-1) = 65535L;
			*(tempscreenptr-SCREENWIDTH-SCREENWIDTH+1) = 65535L;

			*(tempscreenptr-(SCREENWIDTH+1)-SCREENWIDTH-SCREENWIDTH) = 65535L;
			*(tempscreenptr-SCREENWIDTH-SCREENWIDTH-SCREENWIDTH) = 65535L;

			break;

		case S:
			*tempscreenptr = 65535L;
			*(tempscreenptr-1) = 65535L;

			*(tempscreenptr+(SCREENWIDTH-1)) = 65535L;
			*(tempscreenptr+SCREENWIDTH) = 65535L;
			*(tempscreenptr+(SCREENWIDTH-1)-1) = 65535L;
			*(tempscreenptr+SCREENWIDTH+1) = 65535L;
			*(tempscreenptr+(SCREENWIDTH-1)-2) = 65535L;
			*(tempscreenptr+SCREENWIDTH+2) = 65535L;

			*(tempscreenptr+(SCREENWIDTH-1)+SCREENWIDTH) = 65535L;
			*(tempscreenptr+SCREENWIDTH+SCREENWIDTH) = 65535L;
			*(tempscreenptr+(SCREENWIDTH-1)+SCREENWIDTH-1) = 65535L;
			*(tempscreenptr+SCREENWIDTH+SCREENWIDTH+1) = 65535L;

			*(tempscreenptr+(SCREENWIDTH-1)+SCREENWIDTH+SCREENWIDTH) = 65535L;
			*(tempscreenptr+SCREENWIDTH+SCREENWIDTH+SCREENWIDTH) = 65535L;

			*(tempscreenptr-(SCREENWIDTH+1)) = 65535L;
			*(tempscreenptr-SCREENWIDTH) = 65535L;

			*(tempscreenptr-(SCREENWIDTH+1)-SCREENWIDTH) = 65535L;
			*(tempscreenptr-SCREENWIDTH-SCREENWIDTH) = 65535L;

			*(tempscreenptr-(SCREENWIDTH+1)-SCREENWIDTH-SCREENWIDTH) = 65535L;
			*(tempscreenptr-SCREENWIDTH-SCREENWIDTH-SCREENWIDTH) = 65535L;

			break;

		case E:
			*tempscreenptr = 65535L;
			*(tempscreenptr-SCREENWIDTH) = 65535L;

			*(tempscreenptr-1) = 65535L;
			*(tempscreenptr-(SCREENWIDTH+1)) = 65535L;

			*(tempscreenptr-2) = 65535L;
			*(tempscreenptr-(SCREENWIDTH+2)) = 65535L;

			*(tempscreenptr-3) = 65535L;
			*(tempscreenptr-(SCREENWIDTH+3)) = 65535L;


			*(tempscreenptr+1) = 65535L;
			*(tempscreenptr-(SCREENWIDTH-1)) = 65535L;
			*(tempscreenptr+1+SCREENWIDTH) = 65535L;
			*(tempscreenptr-(SCREENWIDTH-1)-SCREENWIDTH) = 65535L;
			*(tempscreenptr+1+SCREENWIDTH+SCREENWIDTH) = 65535L;
			*(tempscreenptr-(SCREENWIDTH-1)-SCREENWIDTH-SCREENWIDTH) = 65535L;

			*(tempscreenptr+2) = 65535L;
			*(tempscreenptr-(SCREENWIDTH-2)) = 65535L;
			*(tempscreenptr+2+SCREENWIDTH) = 65535L;
			*(tempscreenptr-(SCREENWIDTH-2)-SCREENWIDTH) = 65535L;

			*(tempscreenptr+3) = 65535L;
			*(tempscreenptr-(SCREENWIDTH-3)) = 65535L;

			break;

		case W:
			tempscreenptr -= SCREENWIDTH;

			*tempscreenptr = 65535L;
			*(tempscreenptr+SCREENWIDTH) = 65535L;

			*(tempscreenptr+1) = 65535L;
			*(tempscreenptr+(SCREENWIDTH+1)) = 65535L;

			*(tempscreenptr+2) = 65535L;
			*(tempscreenptr+(SCREENWIDTH+2)) = 65535L;

			*(tempscreenptr+3) = 65535L;
			*(tempscreenptr+(SCREENWIDTH+3)) = 65535L;


			*(tempscreenptr-1) = 65535L;
			*(tempscreenptr+(SCREENWIDTH-1)) = 65535L;
			*(tempscreenptr-1-SCREENWIDTH) = 65535L;
			*(tempscreenptr+(SCREENWIDTH-1)+SCREENWIDTH) = 65535L;
			*(tempscreenptr-1-SCREENWIDTH-SCREENWIDTH) = 65535L;
			*(tempscreenptr+(SCREENWIDTH-1)+SCREENWIDTH+SCREENWIDTH) = 65535L;

			*(tempscreenptr-2) = 65535L;
			*(tempscreenptr+(SCREENWIDTH-2)) = 65535L;
			*(tempscreenptr-2-SCREENWIDTH) = 65535L;
			*(tempscreenptr+(SCREENWIDTH-2)+SCREENWIDTH) = 65535L;

			*(tempscreenptr-3) = 65535L;
			*(tempscreenptr+(SCREENWIDTH-3)) = 65535L;

			break;

		} // end switch on DIR



		switch( pathptr->path[currpath] )
		{
		case N:	
			mapy--;
			break;
		case S:		
			mapy++;
			break;
		case E:		
			mapx++;
			break;
		case W:		
			mapx--;
			break;
		} // end switch on path

		currpath++;

	} // end while currpath is not a direction (NULL)


// Draw car ...
		screenx = 200L + times10(mapx) + 5;
		screeny = times10(mapy) + 5;

		if( (screenx > 0) && (screenx < SCREENWIDTH) && (screeny > 0) && (screeny < SCREENHEIGHT) )
		{
			tempscreenptr = g_vsptr + VSOFFSET + times800(screeny) + screenx;
			*tempscreenptr = 31;
			*(tempscreenptr-1) = 31;
			*(tempscreenptr+1) = 31;
			*(tempscreenptr-SCREENWIDTH) = 31;
			*(tempscreenptr+SCREENWIDTH) = 31;
			*(tempscreenptr-(SCREENWIDTH+1)) = 31;
			*(tempscreenptr+(SCREENWIDTH+1)) = 31;
			*(tempscreenptr-(SCREENWIDTH-1)) = 31;
			*(tempscreenptr+(SCREENWIDTH-1)) = 31;
		} // end draw car




	UNLOCKVS;

	return TRUE;
} // end drawpath




// This is called when RMB pushed in GS_EDITMAP ...
int makepossiblepath( void )
{
	MSG msg;
//	int index;

	POSSIBLEPATH *pathptr;


	int pathno;

	pathno = 0;
	for( ;; )
	{
		if( pathno == 256 ) return FALSE;

		if( possiblepath[pathno].isused )
		{
			pathno++;
			continue;
		} // end if isused

		break;
	} // end find open slot

	currpathno = pathno;

	pathptr = &possiblepath[pathno];
	ZeroMemory( pathptr, sizeof(POSSIBLEPATH) );
	
	carmapx = (cursorx-200)/10;
	carmapy = (cursory)/10;

	pathptr->startx = carmapx;
	pathptr->starty = carmapy;



	pushgamescreen( gamescreen );
	gamescreen = GS_MAKEPATH;

//	setcursormode( CURSOROFF );
	drawcitymap();


	g_response = 0xFF;

// Main Confirm Loop ... let's see if this works ...
    while( 1 )
    {
				if( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) )
				{
					if( !GetMessage( &msg, NULL, 0, 0 ) )
					{
						finiObjects();
						DestroyWindow( hwndmain );
						exit(0);
					} // end if WM_QUIT received
				TranslateMessage(&msg); 
				DispatchMessage(&msg);
				}
				else if( bActive && fullscreen )
				{
// TODO -- Change to just copying pre-rendered background ...
//					drawcitymap();
					copycitygraphic();

					drawpath( pathno );


					centertext( "MAKE PATH", 0, 200, SCREENWIDTH );
					displayscreen();
// break out if g_response has changed (i.e. user has selected Yes or No) ....
					if( g_response != 0xFF ) break;
				}

				else
				{
					// make sure we go to sleep if we have nothing else to do
					WaitMessage();
				}

	} // end while loop

	if( g_response == TRUE )
	{
		pathptr->isused = 1;
		city.numofpaths++;
	} // end if DID create
	else
	{
		ZeroMemory( pathptr, sizeof(POSSIBLEPATH) );
	} // end if failed to create

	g_response = 0xFF;	// Gotta reset this so the previous game screen doesn't get it too ...


	setcursormode( MENUCURSOR );

	gamescreen = popgamescreen();
	refreshscreen();

	return TRUE;

} // end makepossiblepath







int makepathmessagehandler( UINT message, WPARAM wParam, LPARAM lParam )
{
//	int index;
//	int buttonno;
	POSSIBLEPATH *pathptr;


	pathptr = &possiblepath[currpathno];


	switch( message )
	{
	case WM_KEYDOWN:
		switch( wParam )
		{
		case VK_ESCAPE:
			g_response = FALSE;
			break;

		case VK_RETURN:
			g_response = TRUE;
			break;

		case VK_LEFT:
			pathptr->path[ pathptr->pathno ] = W;
			pathptr->pathno++;

			carmapx--;
			break;

		case VK_RIGHT:
			pathptr->path[ pathptr->pathno ] = E;
			pathptr->pathno++;

			carmapx++;
			break;

		case VK_UP:
			pathptr->path[ pathptr->pathno ] = N;
			pathptr->pathno++;

			carmapy--;
			break;

		case VK_DOWN:
			pathptr->path[ pathptr->pathno ] = S;
			pathptr->pathno++;

			carmapy++;
			break;

		} // end switch on WHICH key got pressed


		// Check for moved off map ...
		if( (carmapx < 0) || (carmapx == 60) || (carmapy < 0) || (carmapy == 60) )
		{
			g_response = TRUE;
		} // end if moved off map


		break; // end WM_KEYDOWN


// TODO -- Move this to game handler!

	case WM_LBUTTONDOWN:
		break;

	case WM_MOUSEMOVE:
		break;

	} // end switch on Windows Messages for GS_MAINMENU

	return TRUE;
} // end makepathmessagehandler


















/*
void drawcurrentsection( void )
{
	word *tempscreenptr;
	word *temppicptr;

	byte lineindex;

	byte xsize, ysize;
	int screenx, screeny;

	if( lmb || rmb || drawingpath )
	{
		return;
	} // end if either button down ...

	if( cursorx < 200 ) return;


	xsize = citysection[currsection].xsize;
	ysize = citysection[currsection].ysize;

	screenx = cursorx - (cursorx % 20);
	screeny = cursory - (cursory % 20);

	if( screenx > SCREENWIDTH - times20(xsize) ) return;
	if( screeny > SCREENHEIGHT - times20(ysize) ) return;


	LOCKVS;

	tempscreenptr = g_vsptr + VSOFFSET + times800(screeny) + screenx;

	temppicptr = sectionsptr + times640(citysection[currsection].graphicy) + citysection[currsection].graphicx;

	for( lineindex = 0; lineindex < GRIDSIZE*ysize; lineindex++ )
	{
		memcpy( tempscreenptr, temppicptr, (GRIDSIZE*2)*ysize );
		tempscreenptr += SCREENWIDTH;
		temppicptr += 640L;
	} // end lineindex loop

	UNLOCKVS;


} // end drawcurrentsection
*/


void drawcurrentsection( void )
{
	HRESULT ddrval;
	RECT rcRect, rcRect2;

//	DDBLTFX ddbltfx;


	byte xsize, ysize;
	int screenx, screeny;

// For rotation ...
	word *srcptr;
	word *destptr;
	int srcx, srcy;
	int destx, desty;
	int width, height;
	DDSURFACEDESC2 ddsd;


	if( lmb || rmb || drawingpath )
	{
		return;
	} // end if either button down ...

	if( cursorx < 200 ) return;


	xsize = citysection[currsection].xsize;
	ysize = citysection[currsection].ysize;

	screenx = cursorx - (cursorx % 20);
	screeny = cursory - (cursory % 20);

	if( screenx > SCREENWIDTH - times20(xsize) ) return;
	if( screeny > SCREENHEIGHT - times20(ysize) ) return;


	rcRect2.left = citysection[currsection].graphicx;
	rcRect2.top  = citysection[currsection].graphicy;

	rcRect2.right  = rcRect2.left + (xsize * GRIDSIZE);
	rcRect2.bottom = rcRect2.top  + (ysize * GRIDSIZE);

	rcRect.left = screenx;
	rcRect.top = screeny;
	
	rcRect.right = rcRect.left + (xsize * GRIDSIZE);
	rcRect.bottom = rcRect.top + (ysize * GRIDSIZE);


//	ZeroMemory( &ddbltfx, sizeof(DDBLTFX) );
//	ddbltfx.dwSize = sizeof( DDBLTFX );


// Rotate if needed ...
	if( currentrotation || isflipped )
	{
		memset( &ddsd, 0, sizeof(ddsd) );
		ddsd.dwSize = sizeof(ddsd);
		
		ddrval = DDERR_WASSTILLDRAWING;
		
		while( ddrval == DDERR_WASSTILLDRAWING )
		{
			ddrval = lpDDS[DDS_SECTIONS]->Lock( NULL, &ddsd, DDLOCK_SURFACEMEMORYPTR, NULL );
		}

		if( ddrval != DD_OK )
		{
			ShowDDError("Lock()", ddrval);
			cleanup( MISC, "Couldn't Lock() Sections Surface!" );
		}
		
		srcptr = (word *)ddsd.lpSurface + rcRect2.left + (rcRect2.top * 640L);


		width = times20(xsize);
		height = times20(ysize);

		switch( currentrotation )
		{
		case 0:
			for( srcy = 0; srcy < height; srcy++ )
			{
				for( srcx = 0; srcx < width; srcx++ )
				{
					desty = srcy;
					destx = (width-srcx-1);

					destptr = (word *)ddsd.lpSurface + (560L+(560L*640L)) +
						destx + (desty * 640L);

					*destptr = *srcptr;

					srcptr++;
				} // end srcx loop

				srcptr += 640L - width;
			} // end srcy loop

			break; // end case no rotation but IS flipped

		case 1:
			for( srcy = 0; srcy < height; srcy++ )
			{
				for( srcx = 0; srcx < width; srcx++ )
				{
					if( isflipped )
					{
						desty = (width-srcx-1);
						destx = (height-srcy-1);
					}
					else
					{
						desty = srcx;
						destx = (height-srcy-1);
					}

					destptr = (word *)ddsd.lpSurface + (560L+(560L*640L)) +
						destx + (desty * 640L);

					*destptr = *srcptr;

					srcptr++;
				} // end srcx loop

				srcptr += 640L - width;
			} // end srcy loop

			break; // end case 90 degrees

		case 2:
			for( srcy = 0; srcy < height; srcy++ )
			{
				for( srcx = 0; srcx < width; srcx++ )
				{
					if( isflipped )
					{
						desty = (height-srcy-1);
						destx = srcx;
					}
					else
					{
						desty = (height-srcy-1);
						destx = (width-srcx-1);
					}

					destptr = (word *)ddsd.lpSurface + (560L+(560L*640L)) +
						destx + (desty * 640L);

					*destptr = *srcptr;

					srcptr++;
				} // end srcx loop

				srcptr += 640L - width;
			} // end srcy loop

			break; // end case 180 degrees

		case 3:
			for( srcy = 0; srcy < height; srcy++ )
			{
				for( srcx = 0; srcx < width; srcx++ )
				{
					if( isflipped )
					{
						desty = srcx;
						destx = srcy;
					}
					else
					{
						desty = (width-srcx-1);
						destx = srcy;
					}

					destptr = (word *)ddsd.lpSurface + (560L+(560L*640L)) +
						destx + (desty * 640L);

					*destptr = *srcptr;

					srcptr++;
				} // end srcx loop

				srcptr += 640L - width;
			} // end srcy loop

			break; // end case 270 degrees

		} // end switch on currentrotation

		rcRect2.left = 560;
		rcRect2.top = 560;
		rcRect2.right = 560 + width;
		rcRect2.bottom = 560 + height;

		ddrval = lpDDS[DDS_SECTIONS]->Unlock( NULL );
		if( ddrval != DD_OK )
		{
			ShowDDError("Unlock()", ddrval);
			cleanup( MISC, "Couldn't Unlock() Sections Surface!" );
		}

	} // end if rotated


// Blit Final bitmap ...
    while( 1 )
    {
        ddrval = lpDDSVS->Blt( &rcRect, lpDDS[DDS_SECTIONS],
            &rcRect2, DDBLT_KEYSRC, NULL );

		if( ddrval == DD_OK ) break;
		if( ddrval == DDERR_SURFACELOST )
		{
			ddrval = restoreAll();
			if( ddrval != DD_OK )
			{
				ShowDDError( "restoreAll()", ddrval );
				cleanup( MISC, NULL );
			}
//			refreshscreen();
			continue;

		}
		if( ddrval != DDERR_WASSTILLDRAWING )
		{
			ShowDDError( "BltFast() in drawcurrentsection()", ddrval );
			sprintf( tempstr, "(%d,%d) - (%d,%d)", rcRect.left, rcRect.top, rcRect.right, rcRect.bottom );
			cleanup( MISC, tempstr );
		}

	} // end loop

    if(ddrval != DD_OK)
	{
		ShowDDError( "BltFast() in drawcurrentsection()", ddrval );
		cleanup( OK, NULL );
	}


/* Hardware FLIP ...

	switch( currentrotation )
	{
	case 1:
		ddbltfx.dwDDFX = DDBLTFX_MIRRORUPDOWN;
		break;
	case 2:
		ddbltfx.dwDDFX = DDBLTFX_MIRRORLEFTRIGHT;
		break;
	case 3:
		ddbltfx.dwDDFX = DDBLTFX_MIRRORUPDOWN | DDBLTFX_MIRRORLEFTRIGHT;
		break;

	} // end switch on currentrotation



    while( 1 )
    {
        ddrval = lpDDSVS->Blt( &rcRect, lpDDS[DDS_SECTIONS],
            &rcRect2, DDBLT_KEYSRC | DDBLT_DDFX, &ddbltfx );

		if( ddrval == DD_OK ) break;
		if( ddrval == DDERR_SURFACELOST )
		{
			ddrval = restoreAll();
			if( ddrval != DD_OK )
			{
				ShowDDError( "restoreAll()", ddrval );
				cleanup( MISC, NULL );
			}

		}
		if( ddrval != DDERR_WASSTILLDRAWING )
		{
			ShowDDError( "BltFast() in drawcitymap()", ddrval );
			sprintf( tempstr, "(%d,%d) - (%d,%d)", rcRect.left, rcRect.top, rcRect.right, rcRect.bottom );
			cleanup( MISC, tempstr );
		}

	} // end loop

    if(ddrval != DD_OK)
	{
		ShowDDError( "BltFast()", ddrval );
		cleanup( OK, NULL );
	}

*/



	
} // end drawcurrentsection



int editmap( void )
{
	MSG msg;
//	int index;


	pushgamescreen( gamescreen );
	gamescreen = GS_EDITMAP;

	setcursormode( MENUCURSOR );


	loadcitymap( -1 );
	currpathno = 0;

	drawcitymap();
	redrawmap = 0;


	g_response = 0xFF;

// Main Confirm Loop ... let's see if this works ...
    while( 1 )
    {
				if( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) )
				{
					if( !GetMessage( &msg, NULL, 0, 0 ) )
					{
						finiObjects();
						DestroyWindow( hwndmain );
						exit(0);
					} // end if WM_QUIT received
				TranslateMessage(&msg); 
				DispatchMessage(&msg);
				}
				else if( bActive && fullscreen )
				{
					if( redrawmap )
					{
						redrawmap = 0;
						drawcitymap();
//						copycitygraphic();
					} // end if redrawingmap
					else
						copycitygraphic();

					drawinterface();

myfont = EURO;
centertext( cityname, 600-32, 200, SCREENWIDTH );


					drawcurrentsection();


					if( drawingpath )
					{
						myfont = EURO;
						centertext( "EDITTING PATHS ...", 0, 200, SCREENWIDTH );

						if( city.numofpaths != 0 )
						{
							sprintf( tempstr, "PATH: %d", currpathno );
							centertext( tempstr, 20, 200, SCREENWIDTH );
							drawpath( currpathno );
						}
					}
					else
					{
						myfont = EURO;
						centertext( "EDIT MAP GRAPHICS ...", 0, 200, SCREENWIDTH );
					} // end if NOT drawingpath


					displayscreen();
// break out if g_response has changed (i.e. user has selected Yes or No) ....
					if( g_response != 0xFF ) break;
				}

				else
				{
					// make sure we go to sleep if we have nothing else to do
					WaitMessage();
				}

	} // end while loop

	g_response = 0xFF;	// Gotta reset this so the previous game screen doesn't get it too ...


	gamescreen = popgamescreen();
	refreshscreen();

	return TRUE;

} // end editmap







int editmapmessagehandler( UINT message, WPARAM wParam, LPARAM lParam )
{
//	int index;
//	int buttonno;
	int pathno;
	int mapspace;

	OPENFILENAME ofn;
	int result;
	char tempfilename[MAX_PATH+1];




	switch( message )
	{
	case WM_KEYDOWN:
		switch( wParam )
		{
		case VK_ESCAPE:
			if( !confirm( "SAVE CITY?" ) )
			{
				g_response = TRUE;
				break;
			} // end if NOT saving city ...
			// else go ahead and save file, too ...

			g_response = TRUE; // Causes it to exit editor after saving city ...

		case 'S':
//				sprintf( filename, "cities\\default.cty" );

				ZeroMemory( &ofn, sizeof(OPENFILENAME) );

				ofn.lStructSize = sizeof( OPENFILENAME );
				ofn.hwndOwner = hwndmain;
				strcpy( tempfilename, "*.cty" );
				ofn.lpstrFile = tempfilename;
				ofn.nMaxFile = MAX_PATH+1;
				ofn.lpstrInitialDir = "cities";
				ofn.Flags = OFN_NOCHANGEDIR;
				ofn.lpstrDefExt = "cty";
				ofn.lpstrTitle = "Save As ...";

				lpDD4->FlipToGDISurface();

				result = GetSaveFileName( &ofn );

				if( result == 0 ) break; // end if user cancelled ...

				strcpy( filename, ofn.lpstrFile );

				strcpy( cityname, filename );


				filehandle = CreateFile( filename,           // create MYFILE.TXT 
				     GENERIC_WRITE,                // open for writing 
					0,                            // do not share 
					NULL,                         // no security 
					CREATE_ALWAYS,                // overwrite existing 
					FILE_ATTRIBUTE_NORMAL |       // normal file 
					FILE_FLAG_OVERLAPPED,         // asynchronous I/O 
					NULL);                        // no attr. template 

				if( filehandle == INVALID_HANDLE_VALUE ) cleanup( NOFILE, filename );

				WriteFile( filehandle, citymap, 30*30*4, &numofbytesread, NULL );
				WriteFile( filehandle, possiblepath, sizeof(POSSIBLEPATH)*256, &numofbytesread, NULL );

				WriteFile( filehandle, &city, sizeof(CITY), &numofbytesread, NULL );

				WriteFile( filehandle, rotationmap, GRIDWIDTH*GRIDWIDTH, &numofbytesread, NULL );

				CloseHandle( filehandle );

				break;

		case 'L':
			loadcitymap( -1 );
			currpathno = 0;
			redrawmap = 1;
			break;



		case VK_DELETE:
			int index;

			if( !drawingpath ) break;

			if( city.numofpaths == 0 ) break;

			possiblepath[currpathno].isused = 0;
			city.numofpaths--;

			for( index = currpathno; index < 255; index++ )
			{
				memcpy( (void *)&possiblepath[index], (void *)&possiblepath[index+1], sizeof(possiblepath[index]) );
			} // end shift all to left once


			if( city.numofpaths == 0 )
			{
				drawingpath = 0;
				break;
			} // end if no more paths


		case VK_LEFT:
			if( drawingpath )
			{
				if( city.numofpaths == 0 ) break;

				pathno = currpathno;

				for( ;; )
				{
					pathno--;

					if( pathno == -1 ) pathno = 255;
					if( possiblepath[pathno].isused ) break;
				} 

			currpathno = pathno;
			break;
			} // end if drawingpath

			currsection--;
			if( currsection < 0 ) currsection = 0;
			break;

		case VK_RIGHT:
			if( drawingpath )
			{
				if( city.numofpaths == 0 ) break;

				pathno = currpathno;

				for( ;; )
				{
					pathno++;

					if( pathno == 255 ) pathno = 0;
					if( possiblepath[pathno].isused ) break;
				} 

			currpathno = pathno;
			break;
			} // end if drawingpath


			currsection++;
			if( currsection >= NUMOFCITYSECTIONS ) currsection = NUMOFCITYSECTIONS-1;
			break;


		case 'P':
			drawingpath ^= 1;
			break;

		case 'G':
			redrawmap = 1;
			gridon ^= 1;
			break;

		case VK_NUMPAD6:
			if( ++currentrotation == 4 ) currentrotation = 0;
			break;
		case VK_NUMPAD4:
			if( currentrotation == 0 ) currentrotation = 4;
			currentrotation--;
			break;
		case VK_NUMPAD8:
			isflipped ^= 1;
			break;

		} // end switch on WHICH key got pressed

		break; // end WM_KEYDOWN




	case 0x020A: // WM_MOUSEWHEEL
		short int distance;

		distance = (short) HIWORD(wParam);

		if( distance >= 0 )
		{
			currsection--;
			if( currsection < 0 ) currsection = 0;
		} // end if moved up 
		else
		{
			currsection++;
			if( currsection >= NUMOFCITYSECTIONS ) currsection = NUMOFCITYSECTIONS-1;
		} // end if moved down

		break; // end WM_MOUSEWHEEL



	case WM_LBUTTONDOWN:
		if( cursorx < 200 ) break;

		if( drawingpath )
		{
			makepossiblepath();
			break;
		} // end if drawingpath

// TODO -- Take out DIV		
		mapspace = ((cursory/20)*30) + ((cursorx-200)/20);
		citymap[mapspace] = currsection;

		rotationmap[mapspace] = currentrotation;

		if( isflipped ) rotationmap[mapspace] += 128;		// Add flipped flag

		redrawmap = 1;
		break;


	case WM_RBUTTONDOWN:
		if( cursorx < 200 ) break;

		if( drawingpath )
		{
			makepossiblepath();
			break;
		} // end if drawingpath

		mapspace = ((cursory/20)*30) + ((cursorx-200)/20);
		citymap[mapspace] = 0;

		redrawmap = 1;
		break;



	case WM_MOUSEMOVE:
		if( drawingpath ) break;

		if( lmb )
		{
			if( cursorx < 200 ) break;
// TODO -- Take out DIV		
			mapspace = ((cursory/20)*30) + ((cursorx-200)/20);
			citymap[mapspace] = currsection;
			redrawmap = 1;
		} // end if LMB down

		if( rmb )
		{
			if( cursorx < 200 ) break;
// TODO -- Take out DIV		
			mapspace = ((cursory/20)*30) + ((cursorx-200)/20);
			citymap[mapspace] = 0;
			redrawmap = 1;
		} // end if LMB down

		break;

	} // end switch on Windows Messages for GS_MAINMENU

	return TRUE;
} // end editmapmessagehandler



