/*
globals.cpp
globals ...

Copyright (C) 1995-2005  Everett Bell

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/



#include "globals.h"



byte editmode = 0;
int editfunction;

int currsection = 0;

// Used for right mouse click select lists ...
SELECTOPTION selectoption[32];
int numoptions = 0;
byte selectedoption;
int listboxx, listboxy;
int listwidth;



#ifdef EDITORS
// Editor globals ... removed if not including editors ...

#endif

byte tickgoneby = 0;


MEMORYSTATUS memstatus;


#ifdef DEBUG
HANDLE debugfh;
char debugstr[128];
char debugstr2[128];
#endif


// Main Globals ...

HWND hwndmain = NULL;
HINSTANCE hInst;
BOOL bActive;	// is application active?

byte fullscreen = 0;

byte indrawscreen = 0;

dword nextframecount = 0L;
byte gamespeed = 2L;



// Directory the game is started in ...
char homedir[MAX_PATH+1];
char tempdir[MAX_PATH+1];

char lastpath[MAX_PATH+1];

char filename[MAX_PATH+1];
char sfilename[MAX_PATH+1];

HANDLE filehandle;



DWORD numofbytesread;	// for all ReadFile() operations



int memoryused = 0;


byte *tempdata;




// Clock stuff ...
UINT clockid;
volatile dword tickcount = 0L;
volatile dword lighttickcount = 0L;

dword framerate = 4L;



// Graphics variables ...
BOOL screenlocked = 0;

RGB16 rgb16;



// Used to Lock and Unlock VS for access to data ...
DDSURFACEDESC2 g_ddsd;
HRESULT g_ddrval;
HRESULT g_ddrval2;
word *g_vsptr;

// Updated every time a new bmp is loaded ... copy if needed
int g_height;
int g_width;


SPRITE sprite[16];
ANIMSPRITE animsprite[16];


// Represents what part of the game the user is in (Menu, Campaign, Combat, etc.)
byte gamescreen = 0;

// Gonna try a gamescreen stack ... pushing and popping ...
byte gamescreenstack[32];

// Used for okbox() and confirm(), etc. ...
byte g_response;


// Cursor stuff ...
int cursorx = 320;
int cursory = 240;

byte cursorframe = 0;
byte cursoranimated = 0;
dword cursortickcount = 0;


byte lmb = 0;
byte rmb = 0;

byte waitingforlmbup = 0;	// I'm using this to get rid of the first occurence of WM_LBUTTONUP

byte cursormode = MENUCURSOR;

dword cursorpicx = 0;
dword cursorpicy = 0;



// Derived from GetPixelFormat ...
word rmask, gmask, bmask;
byte rbitshift, gbitshift, bbitshift;
byte rnumbits, gnumbits, bnumbits;
byte pixelformat;


word r, g, b;
word r1, g1, b1;
word r2, g2, b2;

word *rptr;
word *gptr;
word *bptr;
word *r1ptr;
word *g1ptr;
word *b1ptr;
word *r2ptr;
word *g2ptr;
word *b2ptr;


WORD g_color;
WORD color1;
WORD color2;

word *g_colorptr;






BOOL mouseon = 1;




int oldtime = 0;

int numframes = 0;
float fps;
int currtime = 0;
BOOL fpson = 0;
dword resetfps = 0;
dword frametickcount = 0;
char fpsstr[32];

char tempstr[1024];
char tempstr2[512];

// String Resources ... localization
char string[256]; // For loading temporary string resources ...
int languageoffset = ENGLISH;

char okboxtext[128];


LPDIRECTDRAW			lpDD;		// DirectDraw object
LPDIRECTDRAW4			lpDD4;		// DirectDraw4 object
LPDIRECTDRAWSURFACE4	lpDDSPrimary;	// DirectDraw primary surface
LPDIRECTDRAWSURFACE4	lpDDSBack;	// DirectDraw back surface
LPDIRECTDRAWSURFACE4	lpDDSVS;	// Offscreen Virtual Screen in Video RAM

//LPDIRECTDRAWSURFACE4	lpDDSCityMap;	// Video RAM Surface for citymap

LPDIRECTDRAWPALETTE		lpDDPalette;	// Palette


LPDIRECTDRAWSURFACE4 lpDDS[NUMSURFACES];
char *szsurface[NUMSURFACES] =
{
	"CURSORS",
	"bitmaps\\interface.bmp",
	"bitmaps\\citymap.bmp",
	"bitmaps\\sections.bmp",
	"bitmaps\\ground.bmp",
	"fonts\\eurofont.bmp",
	"fonts\\eurofontdark.bmp",
	"bitmaps\\warninglevel.bmp",
	"bitmaps\\topbar.bmp",
	"bitmaps\\buttons\\button1.bmp",
	"bitmaps\\cars.bmp",
	"bitmaps\\mmnolight.bmp",
	"bitmaps\\mmredlight.bmp",
	"bitmaps\\mmyellowlight.bmp",
	"bitmaps\\mmgreenlight.bmp",
	"bitmaps\\chooseinterface.bmp"
};


MYFONT myfonttype[NUMOFFONTS];

char myfont = EURO;
char recessed = 0;

word textr = 24;
word textg = 24;
word textb = 24;
byte textcolor = 1;
char textinbounds = 1;



// DirectSound ...

BOOL soundon = 1;

LPDIRECTSOUND               lpds;
DSBUFFERDESC                dsbdesc;
LPDIRECTSOUNDBUFFER         lpdsb;	// Streaming buffer
LPDIRECTSOUNDBUFFER         lpdsbPrimary;
LPDIRECTSOUNDNOTIFY         lpdsNotify;
WAVEFORMATEX                *pwfx;
HMMIO                       hmmio;
MMCKINFO                    mmckinfoData, mmckinfoParent;
DSBPOSITIONNOTIFY           rgdsbpn[NUMEVENTS];
HANDLE                      rghEvent[NUMEVENTS];

LPDIRECTSOUNDBUFFER			lpdsbuffer[NUMSOUNDS];
DSBUFFERDESC				dsbufferdesc[NUMSOUNDS];

char *szsoundname[NUMSOUNDS+1] = {
	NULL, 
	"wave\\click.wav",
	"wave\\copappears.wav",
	"wave\\copsiren.wav",
	"wave\\copurgent.wav",
	"wave\\carhorn.wav",
	"wave\\carhorn2.wav",
	"wave\\click.wav",
	"wave\\click.wav",
	"wave\\click.wav",
	"wave\\click.wav",
	"wave\\wingame.wav",
	"wave\\crash.wav",
	"wave\\Paused.wav",
	"wave\\copwhistle.wav",
	"wave\\gameover.wav",
	"wave\\click.wav"
};
 



// Direct Music ...
IDirectMusicPerformance* g_pPerf = NULL;

IDirectMusicLoader* g_pLoader = NULL;

IDirectMusicSegment* g_pMIDISeg = NULL;
IDirectMusicSegment* g_pMIDISeg1 = NULL;
IDirectMusicSegment* g_pMIDISeg2 = NULL;
IDirectMusicSegment* g_pMIDISeg3 = NULL;
IDirectMusicSegment* g_pMIDISegCredits = NULL;

IDirectMusicSegmentState* g_pSegState = NULL;
IDirectMusicSegmentState* g_pSegState1 = NULL;
IDirectMusicSegmentState* g_pSegState2 = NULL;
IDirectMusicSegmentState* g_pSegState3 = NULL;




BUTTON button[16];
// word *buttonpicptr;



// Game Specific graphics ...

CITYSECTION citysection[NUMOFCITYSECTIONS];
//word *sectionsptr; // City Graphics

// word *citymapgraphicptr; // Rendered City Map Graphic ...
// word *cargraphicptr; // Car Graphics
// word *interfacegraphicptr;

int citymap[GRIDWIDTH*GRIDWIDTH];

byte rotationmap[GRIDWIDTH*GRIDWIDTH];

byte lightmap[GRIDWIDTH*GRIDWIDTH];
dword lightwait[GRIDWIDTH*GRIDWIDTH];

int numofcops;

int carmap[GRIDWIDTH*GRIDWIDTH*4];

byte gridon = 1;
byte gamepaused = 0;

CITY city;


// First car in linked list ...
CAR firstcar;
CAR lastcar;

int numofcars = 0;
int numofcopsonmap;
int numofcopsstopped;

POSSIBLEPATH possiblepath[256];


// Settings ...
int difficulty = 1;		// 1 - 40
int score = 0;
int hiscore = 0;
int nextlevelat;


int numofcarsstopped = 0;
int warninglevel = 0;


// For choosefile() ...
char filelist[256][256];
char tempfilelist[256][256];
int numfilesinlist = 0;

int homefileno = 0;

int scrollypos;
float scrollresolution;


// For campaigns ...
int campcityno;
char campaignname[MAX_PATH+1];
char szcampcityname[5][MAX_PATH+1];
BOOL playingcampaign = FALSE;


char cityname[MAX_PATH+1];

BOOL godmodeon = 0;


float versionno = 1.00f;