/*
globals.h
global declarations ...

Copyright (C) 1995-2005  Everett Bell

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <windowsx.h>
#include <ddraw.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include <mmsystem.h>
#include <dsound.h>

#include <dmusicc.h>
#include <dmusici.h>


// #include "resource.h"
#include "ddutil.h"

#include "define.h"

#define NAME "Rush Hour"
#define TITLE "Rush Hour"





extern int currsection;

// Used for right mouse click select lists ...
extern SELECTOPTION selectoption[32];
extern int numoptions;
extern byte selectedoption;
extern int listboxx, listboxy;
extern int listwidth;


extern byte editmode;
extern int editfunction;


#ifdef EDITORS
// Editor globals ... removed if not including editors ...

#endif


extern byte tickgoneby;

extern MEMORYSTATUS memstatus;


#ifdef DEBUG
extern HANDLE debugfh;
extern char debugstr[128];
extern char debugstr2[128];
#endif


// Main Globals ...

extern HWND hwndmain;
extern HINSTANCE hInst;
extern BOOL bActive;	// is application active?

extern byte fullscreen;

extern byte indrawscreen;

extern dword nextframecount;
extern byte gamespeed;



// Directory the game is started in ...
extern char homedir[MAX_PATH+1];
extern char tempdir[MAX_PATH+1];

extern char lastpath[MAX_PATH+1];

extern char filename[MAX_PATH+1];
extern char sfilename[MAX_PATH+1];

extern HANDLE filehandle;



extern DWORD numofbytesread;	// for all ReadFile() operations



extern int memoryused;


extern byte *tempdata;




// Clock stuff ...
extern UINT clockid;
extern volatile dword tickcount;
extern volatile dword lighttickcount;


extern dword framerate;



// Graphics variables ...
extern BOOL screenlocked;

extern RGB16 rgb16;


// Used to Lock and Unlock VS for access to data ...
extern DDSURFACEDESC2 g_ddsd;
extern HRESULT g_ddrval;
extern HRESULT g_ddrval2;

// TODO -- 8bit graphics vs ptr ... 
extern word *g_vsptr;
//extern word *g_vsptr;

// Updated every time a new bmp is loaded ... copy if needed
extern int g_height;
extern int g_width;


extern SPRITE sprite[16];
extern ANIMSPRITE animsprite[16];


// Represents what part of the game the user is in (Menu, Campaign, Combat, etc.)
extern byte gamescreen;

// Gonna try a gamescreen stack ... pushing and popping ...
extern byte gamescreenstack[32];

// Used for okbox() and confirm(), etc. ...
extern byte g_response;


// Cursor stuff ...
extern int cursorx;
extern int cursory;

extern byte cursorframe;
extern byte cursoranimated;
extern dword cursortickcount;


extern byte lmb;
extern byte rmb;

extern byte waitingforlmbup;	// I'm using this to get rid of the first occurence of WM_LBUTTONUP

extern byte cursormode;

extern dword cursorpicx;
extern dword cursorpicy;



// Derived from GetPixelFormat ...
extern word rmask, gmask, bmask;
extern byte rbitshift, gbitshift, bbitshift;
extern byte rnumbits, gnumbits, bnumbits;
extern byte pixelformat;


extern word r, g, b;
extern word r1, g1, b1;
extern word r2, g2, b2;

extern word *rptr;
extern word *gptr;
extern word *bptr;
extern word *r1ptr;
extern word *g1ptr;
extern word *b1ptr;
extern word *r2ptr;
extern word *g2ptr;
extern word *b2ptr;


extern WORD g_color;
extern WORD color1;
extern WORD color2;

extern word *g_colorptr;






extern BOOL mouseon;




extern int oldtime;

extern int numframes;
extern float fps;
extern int currtime;
extern BOOL fpson;
extern dword resetfps;
extern dword frametickcount;
extern char fpsstr[32];

extern char tempstr[1024];
extern char tempstr2[512];

// String Resources ... localization
extern char string[256]; // For loading temporary string resources ...
extern int languageoffset;

extern char okboxtext[128];


extern LPDIRECTDRAW			lpDD;		// DirectDraw object
extern LPDIRECTDRAW4		lpDD4;		// DirectDraw4 object
extern LPDIRECTDRAWSURFACE4	lpDDSPrimary;	// DirectDraw primary surface
extern LPDIRECTDRAWSURFACE4	lpDDSBack;	// DirectDraw back surface
extern LPDIRECTDRAWSURFACE4	lpDDSVS;	// Offscreen Virtual Screen in System Memory

//extern LPDIRECTDRAWSURFACE4	lpDDSCityMap;	// Video RAM Surface for citymap
//extern LPDIRECTDRAWSURFACE4	lpDDSCitySections;	// Video RAM Surface for citymap

extern LPDIRECTDRAWPALETTE	lpDDPalette;	// Palette

extern LPDIRECTDRAWSURFACE4 lpDDS[NUMSURFACES];
extern char *szsurface[NUMSURFACES];

extern MYFONT myfonttype[NUMOFFONTS];

extern char myfont;
extern char recessed;

extern word textr;
extern word textg;
extern word textb;

extern byte textcolor;

extern char textinbounds;



// DirectSound ...

extern BOOL soundon;

extern LPDIRECTSOUND               lpds;
extern DSBUFFERDESC                dsbdesc;
extern LPDIRECTSOUNDBUFFER         lpdsb;
extern LPDIRECTSOUNDBUFFER         lpdsbPrimary;
extern LPDIRECTSOUNDNOTIFY         lpdsNotify;
extern WAVEFORMATEX                *pwfx;
extern HMMIO                       hmmio;
extern MMCKINFO                    mmckinfoData, mmckinfoParent;
extern DSBPOSITIONNOTIFY           rgdsbpn[NUMEVENTS];
extern HANDLE                      rghEvent[NUMEVENTS];
 
extern LPDIRECTSOUNDBUFFER			lpdsbuffer[NUMSOUNDS];
extern DSBUFFERDESC				dsbufferdesc[NUMSOUNDS];

extern char *szsoundname[NUMSOUNDS+1];



// Direct Music ...
extern IDirectMusicPerformance* g_pPerf;

extern IDirectMusicLoader* g_pLoader;

extern IDirectMusicSegment* g_pMIDISeg;
extern IDirectMusicSegment* g_pMIDISeg1;
extern IDirectMusicSegment* g_pMIDISeg2;
extern IDirectMusicSegment* g_pMIDISeg3;
extern IDirectMusicSegment* g_pMIDISegCredits;

extern IDirectMusicSegmentState* g_pSegState;
extern IDirectMusicSegmentState* g_pSegState1;
extern IDirectMusicSegmentState* g_pSegState2;
extern IDirectMusicSegmentState* g_pSegState3;





extern BUTTON button[16];
// extern word *buttonpicptr;




// Game Specific graphics ...

extern CITYSECTION citysection[NUMOFCITYSECTIONS];
// extern word *sectionsptr; // Graphics

// extern word *citymapgraphicptr; // Rendered City Map Graphic ...
// extern word *cargraphicptr; // Car Graphics
// extern word *interfacegraphicptr;

extern int citymap[GRIDWIDTH*GRIDWIDTH];

extern byte rotationmap[GRIDWIDTH*GRIDWIDTH];

extern byte lightmap[GRIDWIDTH*GRIDWIDTH];
extern dword lightwait[GRIDWIDTH*GRIDWIDTH];

extern int numofcops;

extern int carmap[GRIDWIDTH*GRIDWIDTH*4];

extern byte gridon;
extern byte gamepaused;


extern CITY city;

// First car in linked list
extern CAR firstcar;
extern CAR lastcar;

extern int numofcars;
extern int numofcopsonmap;
extern int numofcopsstopped;


extern POSSIBLEPATH possiblepath[256];


// Settings ...
extern int difficulty; // 1 - 40
extern int score;
extern int hiscore;
extern int nextlevelat;


extern int numofcarsstopped;
extern int warninglevel;


extern char filelist[256][256];
extern char tempfilelist[256][256];
extern int numfilesinlist;

extern int homefileno;

extern int scrollypos;
extern float scrollresolution;


// For campaigns ...
extern int campcityno;
extern char campaignname[MAX_PATH+1];
extern char szcampcityname[5][MAX_PATH+1];
extern BOOL playingcampaign;


extern char cityname[MAX_PATH+1];

extern BOOL godmodeon;


extern float versionno;