/*
main.cpp
main game functions ...

Copyright (C) 1995-2005  Everett Bell

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/



#include "globals.h"

#include <time.h>






// Copy VS to Back Buffer, then show cursor and fps(if on), then flip screens ...
void displayscreen( void )
{
    RECT		rcRect, rcRect2;
    HRESULT		ddrval;

	HDC hdc;

	LPPOINT lpPoint;	// For retrieving cursor position ...
	POINT point;


	lpPoint = &point;


//TIMESTAMP;
//sprintf( debugstr, "  displayscreen() called ...\n" );
//WRITETODEBUGFILE;


// TODO -- Can I do something about this ?
	if( !fullscreen ) return;


/* Old way, before moving surfaces to video memory ...

// Blit Virtual Screen to Back Buffer (Can i do this any faster?)
// Yes, if the virtual screen and back buffer are the same size ...

    rcRect.left = 0;
    rcRect.top = 0;
    rcRect.right = SCREENWIDTH;
    rcRect.bottom = SCREENHEIGHT;

    rcRect2.left = VSLEFT;
    rcRect2.top = VSTOP;
    rcRect2.right = VSRIGHT;
    rcRect2.bottom = VSBOTTOM;

    while( 1 )
    {
// If Virtual and Screen are the same ...
        ddrval = lpDDSBack->BltFast( 0, 0, lpDDSVS,
            &rcRect, DDBLTFAST_NOCOLORKEY );
// If Virtual and Screen are NOT the same ...
//        ddrval = lpDDSBack->Blt( &rcRect, lpDDSVS,
//            &rcRect2, NULL, NULL );

		if( ddrval == DD_OK ) break;
		if( ddrval == DDERR_SURFACELOST )
		{
			ddrval = restoreAll();
			if( ddrval != DD_OK )
			{
				ShowDDError( "restoreAll in Blt() for VS", ddrval );
				cleanup( OK, NULL );
			} // end if couldn't restore all
			continue;
		}
		if( ddrval != DDERR_WASSTILLDRAWING )
		{
			ShowDDError( "Blt() for VS", ddrval );
			sprintf( tempstr2, "ddrval = %d", ddrval );
			sprintf( tempstr, "rcRect.left = %d\nrcRect.top = %d\nrcRect.right = %d\nrcRect.bottom = %d\nrcRect2.left = %d\nrcRect2.top = %d\nrcRect2.right = %d\nrcRect2.bottom = %d",
				rcRect.left, rcRect.top, rcRect.right, rcRect.bottom, rcRect2.left, rcRect2.top, rcRect2.right, rcRect2.bottom );
			MessageBox( hwndmain, tempstr, tempstr2, MB_OK );
			cleanup( OK, NULL );
		}
	}

*/

// Blt VSCREEN to Back Buffer ...

	rcRect.left = 0;
	rcRect.top = 0;
	rcRect.right = SCREENWIDTH;
	rcRect.bottom = SCREENHEIGHT;



    while( 1 )
    {
        ddrval = lpDDSBack->BltFast( 0, 0, lpDDSVS,
            &rcRect, DDBLTFAST_NOCOLORKEY );
//        ddrval = lpDDSBack->Blt( &rcRect2, lpDDSVS,
//            &rcRect, NULL, NULL );

		if( ddrval == DD_OK ) break;
		if( ddrval == DDERR_SURFACELOST )
		{
			ddrval = restoreAll();
			if( ddrval != DD_OK )
			{
				ShowDDError( "restoreAll()", ddrval );
				cleanup( OK, NULL );
			}

			refreshscreen();
			continue;

		}
		if( ddrval != DDERR_WASSTILLDRAWING )
		{
			ShowDDError( "BltFast() from VSCREEN to Back Buffer!", ddrval );
			cleanup( OK, NULL );
		}

	} // end loop

    if(ddrval != DD_OK)
	{
		ShowDDError( "BltFast()", ddrval );
		cleanup( OK, NULL );
	}




// Show fps ...
	numframes++;

	if( fpson )
	{
//		currtime = GetTickCount();
		fps = (float)numframes / ((float)frametickcount/60);

		if( resetfps >= 60 )
		{
			sprintf( fpsstr, "fps: %d", (int)fps );
			resetfps = 0;
			numframes = 0;
			frametickcount = 0;
		} // end reset every second

//		else
		{
			if (lpDDSBack->GetDC(&hdc) == DD_OK)
			{
				MUSIC_TIME	musictime;


                SetBkColor( hdc, RGB( 0, 0, 0 ) );
                SetTextColor( hdc, RGB( 128, 128, 128 ) );
				sprintf( tempstr, "memoryused = %d", memoryused );
                TextOut( hdc, 0, 0, tempstr, strlen(tempstr) );
				
				sprintf( tempstr, "(%d, %d)  %s", cursorx, cursory, fpsstr );
				TextOut( hdc, 0, 16, tempstr, strlen(tempstr) );

				sprintf( tempstr, "numofcopsonmap = %d, numofcopsstopped = %d", numofcopsonmap, numofcopsstopped );
				TextOut( hdc, 0, 32, tempstr, strlen(tempstr) );

				g_pPerf->GetTime( NULL, &musictime );
				sprintf( tempstr, "musictime = %d", musictime );
				TextOut( hdc, 0, 48, tempstr, strlen(tempstr) );

/*
// gamescreen specific data ...
				switch( gamescreen )
				{
				} // end switch on gamescreen
*/


// Show Which Game Screen ...
				switch( gamescreen )
				{
				case GS_MAINMENU:		sprintf( tempstr, "GS_MAINMENU" ); break;
				case GS_OKBOX:			sprintf( tempstr, "GS_OKBOX" ); break;
				case GS_CONFIRM:		sprintf( tempstr, "GS_CONFIRM" ); break;
				case GS_CHOOSEFILE:		sprintf( tempstr, "GS_CHOOSEFILE" ); break;
				case GS_SELECTLIST:		sprintf( tempstr, "GS_SELECTLIST" ); break;

				case GS_EDITMAP:		sprintf( tempstr, "GS_EDITMAP" ); break;
				case GS_MAKEPATH:		sprintf( tempstr, "GS_MAKEPATH" ); break;

				case GS_GAME:			sprintf( tempstr, "GS_GAME" ); break;
				case GS_CREDITS:		sprintf( tempstr, "GS_CREDITS" ); break;

				case GS_WAITFORINPUT:	sprintf( tempstr, "GS_WAITFORINPUT" ); break;
				} // end switch on gamescreen

				TextOut( hdc, 0, SCREENHEIGHT-16, tempstr, strlen(tempstr) );

				sprintf( tempstr, "cursormode %d - (%d, %d)", cursormode, cursorpicx, cursorpicy );
				TextOut( hdc, 0, SCREENHEIGHT-32, tempstr, strlen(tempstr) );

                lpDDSBack->ReleaseDC(hdc);
			}

		} // end if not reset yet

	}


	GetCursorPos( lpPoint );

	cursorx = lpPoint->x;
	cursory = lpPoint->y;


	if( mouseon )
	{
// Draw Cursor ...
    rcRect.left = cursorpicx + (cursorframe<<5);
    rcRect.top = cursorpicy;
    rcRect.right = cursorpicx + 32 + (cursorframe<<5);
    rcRect.bottom = cursorpicy + 32;

    rcRect2.left = cursorx;
    rcRect2.top = cursory;
    rcRect2.right = cursorx+32;
    rcRect2.bottom = cursory+32;


	if( rcRect2.right > SCREENWIDTH )
	{
		rcRect.right = cursorpicx + (cursorframe<<5) + 32 - (rcRect2.right-SCREENWIDTH);
		rcRect2.right = SCREENWIDTH;
	} // end if at edge of screen to right

	if( rcRect2.bottom > SCREENHEIGHT )
	{
		rcRect.bottom = cursorpicy + 32 - (rcRect2.bottom-SCREENHEIGHT);
		rcRect2.bottom = SCREENHEIGHT;
	} // end if at edge of screen to bottom



// Blt Cursor ...

    while( 1 )
    {
// Can't do this because I have to cut off cursor at edge of screen ...
//        ddrval = lpDDSBack->BltFast( cursorx, cursory, lpDDS[2],
//            &rcRect, DDBLTFAST_SRCCOLORKEY );
        ddrval = lpDDSBack->Blt( &rcRect2, lpDDS[DDS_CURSORS],
            &rcRect, DDBLT_KEYSRC, NULL );

		if( ddrval == DD_OK ) break;
		if( ddrval == DDERR_SURFACELOST )
		{
			ddrval = restoreAll();
			if( ddrval != DD_OK )
			{
				ShowDDError( "restoreAll()", ddrval );
				cleanup( OK, NULL );
			}
			refreshscreen();
			continue;

		}
		if( ddrval != DDERR_WASSTILLDRAWING )
		{
			ShowDDError( "Blt() in drawing cursor", ddrval );
			sprintf( tempstr, "cursorpicx = %d\ncursorpicy = %d\n\nrcRect.left = %d\nrcRect.top = %d\nrcRect.right = %d\nrcRect.bottom = %d\nrcRect2.left = %d\nrcRect2.top = %d\nrcRect2.right = %d\nrcRect2.bottom = %d",
				cursorpicx, cursorpicy, rcRect.left, rcRect.top, rcRect.right, rcRect.bottom, rcRect2.left, rcRect2.top, rcRect2.right, rcRect2.bottom );
			MessageBox( hwndmain, tempstr, "Error", MB_OK );
			cleanup( OK, NULL );
		}

	}

    if(ddrval != DD_OK)
	{
		ShowDDError( "BltFast()", ddrval );
		cleanup( OK, NULL );
	}

	} // end if mouseon



    // Flip the surfaces
    while( 1 )
    {
		ddrval = lpDDSPrimary->Flip( NULL, 0 );
		if( ddrval == DD_OK ) break;
		if( ddrval == DDERR_SURFACELOST )
		{
			ddrval = restoreAll();
			if( ddrval != DD_OK )
			{
				ShowDDError( "restoreAll()", ddrval );
				break;
			}
			refreshscreen();
			continue;
		}
		if( ddrval != DDERR_WASSTILLDRAWING )
		{
			ShowDDError( "Flip()", ddrval );
			break;
		}

    } // end while(1) loop


} // end displayscreen





// Restores all lost objects							
HRESULT restoreAll( void )
{
    HRESULT	ddrval;
	int sno;

// Gonna try this with the new DD4 function ..

	if( lpDD4 ) // only do it for DD initted
	{

		ddrval = lpDD4->RestoreAllSurfaces();
		if( ddrval != DD_OK )
		{
			return ddrval;
		}


		ddrval = lpDDSVS->Restore();
		if( ddrval != DD_OK )
		{
			ShowDDError( "restoreAll", ddrval );
			cleanup( MISC, NULL );
		} // end if failed to restore

		ddrval = lpDDSPrimary->Restore();
		if( ddrval != DD_OK )
		{
			ShowDDError( "restoreAll", ddrval );
			cleanup( MISC, NULL );
		} // end if failed to restore

		
	} // end if lpDD4 != NULL

/*
	ddrval = lpDDSPrimary->Restore();

    if( ddrval != DD_OK )
	{
		MessageBox( hwndmain, "Primary", TITLE, MB_OK );
		return ddrval;
	}

	ddrval = lpDDSVS->Restore();
    if( ddrval != DD_OK )
	{
		MessageBox( hwndmain, "VS", TITLE, MB_OK );
		return ddrval;
	}
*/


//    ddrval = lpDDSPrimary->Restore();
//    if( ddrval != DD_OK ) return ddrval;


    for( sno = 0; sno < NUMSURFACES; sno++ )
	{
		ddrval = lpDDS[sno]->Restore();
		if( ddrval != DD_OK )
		{
			ShowDDError( "restoreAll", ddrval );
			cleanup( MISC, NULL );
		} // end if failed to restore


		ddrval = DDReLoadBitmap(lpDDS[sno], szsurface[sno]);
		if( ddrval != DD_OK )
		{
			MessageBox( hwndmain, "ReLoadBMP", TITLE, MB_OK );
			return ddrval;
		}

	} // end restore all surfaces



    return ddrval;

} // end restoreAll



// Releases all DD objects ...
void finiObjects( void )
{
	int sno;

	static BOOL hasbeencalled = 0;

	if( hasbeencalled ) return;	// ONLY CALL ONCE!!!

sprintf( debugstr, "finiObjects() ...\n" );
WRITETODEBUGFILE;

// Free Direct Music ...
// If there is any music playing, stop it. This is 
// not really necessary, because the music will stop when
// the instruments are unloaded or the performance is
// closed down.

sprintf( debugstr, "g_pPerf->Stop ...\n" );
WRITETODEBUGFILE;
    if( g_pPerf ) g_pPerf->Stop( NULL, NULL, 0, 0 ); 



// Unload instruments  this will cause silence.
// CloseDown unloads all instruments, so this call is also not 
// strictly necessary.
    if( g_pMIDISeg ) g_pMIDISeg->SetParam(GUID_Unload, -1, 0, 0, (void*)g_pPerf); 
// Release the segment.

sprintf( debugstr, "g_pMIDISeg->Release ...\n" );
WRITETODEBUGFILE;
	if( g_pMIDISeg ) g_pMIDISeg->Release(); 

	g_pMIDISeg = NULL;


// Release the segment.
    if( g_pMIDISeg1 ) g_pMIDISeg1->SetParam(GUID_Unload, -1, 0, 0, (void*)g_pPerf); 

sprintf( debugstr, "g_pMIDISeg1->Release ...\n" );
WRITETODEBUGFILE;
	if( g_pMIDISeg1 ) g_pMIDISeg1->Release(); 

	g_pMIDISeg1 = NULL;

// Release the segment.
    if( g_pMIDISeg2 ) g_pMIDISeg2->SetParam(GUID_Unload, -1, 0, 0, (void*)g_pPerf); 

sprintf( debugstr, "g_pMIDISeg2->Release ...\n" );
WRITETODEBUGFILE;
	if( g_pMIDISeg2 ) g_pMIDISeg2->Release(); 

	g_pMIDISeg2 = NULL;

// Release the segment.
    if( g_pMIDISeg3 ) g_pMIDISeg3->SetParam(GUID_Unload, -1, 0, 0, (void*)g_pPerf); 

sprintf( debugstr, "g_pMIDISeg3->Release ...\n" );
WRITETODEBUGFILE;
	if( g_pMIDISeg3 ) g_pMIDISeg3->Release(); 

	g_pMIDISeg3 = NULL;



// Release the segment.
    if( g_pMIDISegCredits ) g_pMIDISegCredits->SetParam(GUID_Unload, -1, 0, 0, (void*)g_pPerf); 

sprintf( debugstr, "g_pMIDISegCredits->Release ...\n" );
WRITETODEBUGFILE;
	if( g_pMIDISegCredits ) g_pMIDISegCredits->Release(); 

	g_pMIDISegCredits = NULL;



// Causes page fault ... ??? 
// TODO -- FIX! Done!


// CloseDown and Release the performance object.
sprintf( debugstr, "g_pPerf->CloseDown ...\n" );
WRITETODEBUGFILE;
	if( g_pPerf ) g_pPerf->CloseDown();

sprintf( debugstr, "g_pPerf->Release ...\n" );
WRITETODEBUGFILE;
    if( g_pPerf ) g_pPerf->Release();     // Release the loader object.

	g_pPerf = NULL;


sprintf( debugstr, "g_pLoader->Release ...\n" );
WRITETODEBUGFILE;
    if( g_pLoader ) g_pLoader->Release();

	g_pLoader = NULL;



// Release DirectDraw ...

    if( lpDD != NULL )
    {
		if( lpDDSPrimary != NULL )
		{
		    lpDDSPrimary->Release();
			lpDDSPrimary = NULL;
		}

	if( lpDDSVS != NULL )
		{
		    lpDDSVS->Release();
			lpDDSVS = NULL;
		}


	for( sno = 0; sno < NUMSURFACES; sno++ )
		{
			if( lpDDS[sno] != NULL )
			{
				lpDDS[sno]->Release();
				lpDDS[sno] = NULL;
			}
		} // end release all surfaces

	lpDD->Release();
	lpDD = NULL;
    }

// Close DirectSound ...

sprintf( debugstr, "DSExit() ...\n" );
WRITETODEBUGFILE;
	if( !hasbeencalled ) DSExit();

	hasbeencalled = 1;


sprintf( debugstr, "finiObjects() Done.\n" );
WRITETODEBUGFILE;

} // finiObjects






// Called to exit program with 'errortype', and possible extra text ...

void cleanup( char errortype, char *text )
{
	char *caption;

	MSG msg;




		switch( errortype )
		{
			case OK:
				finiObjects();
				PostQuitMessage(0);
#ifdef DEBUG
				sprintf( debugstr, "\nGame Exit ... OK!\n" );
				WriteFile( debugfh, debugstr, strlen(debugstr), &numofbytesread, NULL );

#endif
				goto StartLoop;

			case OUTOFMEM:
				caption = "Out of Memory!";
				break;
			case NOFILE:
				caption = "Unable to access file!";
				break;
			case MISC:
				caption = "Miscellaneous Error!";
				break;

			default:
				caption = "Unknown Error!";
				break;

		} // end switch on errortype






#ifdef DEBUG
			sprintf( debugstr, "\nGame Exit ... \n%s\n%s\n", caption, text );
			WriteFile( debugfh, debugstr, strlen(debugstr), &numofbytesread, NULL );

			CloseHandle( debugfh );
#endif

		
			finiObjects();
			MessageBox( hwndmain, text, caption, MB_OK );
			SetPriorityClass( GetCurrentProcess(), NORMAL_PRIORITY_CLASS );

			PostQuitMessage(0);

			
			
//			DestroyWindow( hwndmain );
//			return;

StartLoop:
    while( 1 )
    {
				if( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) )
				{
					if( !GetMessage( &msg, NULL, 0, 0 ) )
					{
sprintf( debugstr, "Releasing COM ...\n" );
WRITETODEBUGFILE;
						// Release COM.
						CoUninitialize(); 

sprintf( debugstr, " COM Released.\n" );
WRITETODEBUGFILE;

sprintf( debugstr, "Destroying main window ...\n" );
WRITETODEBUGFILE;
						DestroyWindow( hwndmain );
sprintf( debugstr, " Main window destroyed.\n" );
WRITETODEBUGFILE;

				CloseHandle( debugfh );

						exit(0);
					} // end if WM_QUIT received
				TranslateMessage(&msg); 
				DispatchMessage(&msg);
				}
				else if( bActive )
				{
				}

				else
				{
					// make sure we go to sleep if we have nothing else to do
					WaitMessage();
				}

    } // end main loop


/*
        sprintf( tempstr, "Memory used:   %d bytes", memoryused );
        printtocli( tempstr );
        printtocli( " " );
        sprintf( tempstr, "*** Game End:   [%s] ***", _asctime( &time_of_day, buf ) );
        printtocli( tempstr );

        close( debugfh );
*/



} // end cleanup









BOOL setup( void )
{
	initscreen();

	initgraphics();

	inittext();

// TODO -- Add all kinds of other initialization here ...

	loadgraphics();

//	loadcitymap( 0 ); // Loads default map

	return TRUE;
} // end setup




// doInit - do work required for every instance of the application: create the window, initialize data
static BOOL doInit( HINSTANCE hInstance, int nCmdShow )
{
    HWND		hwnd;
//    WNDCLASS		wc;
    DDSURFACEDESC2	ddsd;
    DDSCAPS2		ddscaps;
	DDPIXELFORMAT ddpf;

    HRESULT		ddrval;

	int sno;


	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WindowProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_RUSHHOUR);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)GetStockBrush(BLACK_BRUSH);
	wcex.lpszMenuName	= NAME;
	wcex.lpszClassName	= NAME;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_RUSHHOUR);



	RegisterClassEx(&wcex);

/*
    wc.style = CS_HREDRAW | CS_VREDRAW;
    wc.lpfnWndProc = WindowProc;
    wc.cbClsExtra = 0;
    wc.cbWndExtra = 0;
    wc.hInstance = hInstance;
    wc.hIcon = LoadIcon( hInstance, IDI_APPLICATION );
    wc.hCursor = LoadCursor( NULL, IDC_ARROW );
    wc.hbrBackground = GetStockBrush(BLACK_BRUSH);
    wc.lpszMenuName = NAME;
    wc.lpszClassName = NAME;
    RegisterClass( &wc );
*/
    
    /*
     * create a window
     */
    hwnd = CreateWindowEx(
        WS_EX_TOPMOST,
		NAME,
		TITLE,
		WS_VISIBLE|WS_POPUP,
		0,
		0,
        GetSystemMetrics(SM_CXSCREEN),
        GetSystemMetrics(SM_CYSCREEN),
		NULL,
		NULL,
		hInstance,
		NULL );

    if( !hwnd )	return FALSE;

	hwndmain = hwnd;

    SetFocus( hwnd );    
	ShowWindow( hwnd, nCmdShow );
    UpdateWindow( hwnd );


	// Create the main DirectDraw object
    ddrval = DirectDrawCreate( NULL, &lpDD, NULL );
    if( ddrval != DD_OK )
    {
		ShowDDError( "DirectDrawCreate()", ddrval );
	    finiObjects();
		DestroyWindow( hwnd );
		return FALSE;
    }

    // Get exclusive mode
    ddrval = lpDD->SetCooperativeLevel( hwnd, DDSCL_EXCLUSIVE | DDSCL_FULLSCREEN );
    if( ddrval != DD_OK )
    {
		ShowDDError( "SetCooperativeLevel()", ddrval );
		finiObjects();
	    DestroyWindow( hwnd );
		return FALSE;
    }

	// Query DirectDraw4 Interface
	ddrval = lpDD->QueryInterface(IID_IDirectDraw4, (LPVOID *)&lpDD4); 
	if(ddrval != DD_OK) 
    {
		ShowDDError( "This game requires DirectX version 6.1 or higher ...", ddrval );
		finiObjects();
	    DestroyWindow( hwnd );
		return FALSE;
    }

    // Set the video mode to desired resolution ...
    ddrval = lpDD4->SetDisplayMode( SCREENWIDTH, SCREENHEIGHT, COLORDEPTH, NULL, NULL );
    if( ddrval != DD_OK )
    {
		sprintf( tempstr, "Your screen does not support a resolution of %d by %d with %d bits of color depth ...",
			SCREENHEIGHT, SCREENWIDTH, COLORDEPTH );
		ShowDDError( tempstr, ddrval );
		finiObjects();
	    DestroyWindow( hwnd );
		return FALSE;
    }

	fullscreen = 1;

    // Create the primary surface with 1 back buffer
	memset( &ddsd, 0, sizeof(ddsd) );
    ddsd.dwSize = sizeof( ddsd );

    ddsd.dwFlags = DDSD_CAPS | DDSD_BACKBUFFERCOUNT;
    ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE |
			  DDSCAPS_FLIP |
			  DDSCAPS_COMPLEX;
    ddsd.dwBackBufferCount = 1;

    ddrval = lpDD4->CreateSurface( &ddsd, &lpDDSPrimary, NULL );
    if( ddrval != DD_OK )
    {
		ShowDDError( "Primary Surface -> CreateSurface()", ddrval );
		finiObjects();
	    DestroyWindow( hwnd );
		return FALSE;
    }

// Load Palette here ???
//	lpDDPalette = DDLoadPalette( lpDD4, "CURSORS" );
//	lpDDSPrimary->SetPalette( lpDDPalette );


	memset( &ddscaps, 0, sizeof(ddscaps) );
    ddscaps.dwCaps = DDSCAPS_BACKBUFFER;

    ddrval = lpDDSPrimary->GetAttachedSurface(&ddscaps, &lpDDSBack);
    if( ddrval != DD_OK )
    {
		ShowDDError( "GetAttachedSurface()", ddrval );
		finiObjects();
	    DestroyWindow( hwnd );
		return FALSE;
    }



// Create virtual screen ...
	memset( &ddsd, 0, sizeof(ddsd) );
	ddsd.dwSize = sizeof( ddsd );

    ddsd.dwFlags = DDSD_CAPS | DDSD_HEIGHT | DDSD_WIDTH;
    ddsd.ddsCaps.dwCaps = DDSCAPS_OFFSCREENPLAIN;
    ddsd.dwWidth = VSCREENWIDTH;
    ddsd.dwHeight = VSCREENHEIGHT;

    if (lpDD4->CreateSurface(&ddsd, &lpDDSVS, NULL) != DD_OK)
    {
		ShowDDError( "Virtual Screen -> CreateSurface()", ddrval );
		finiObjects();
	    DestroyWindow( hwnd );
		return FALSE;
    }

	memoryused += VSCREENWIDTH*VSCREENHEIGHT;




    // Create additional surfaces
	for( sno = 0; sno < NUMSURFACES; sno++ )
	{
		switch( sno )
		{
		default:
			lpDDS[sno] = DDLoadBitmap(lpDD4, szsurface[sno], 0, 0);
			break;

		case DDS_SECTIONS:
		case DDS_GROUND:
			lpDDS[sno] = DDLoadBitmap(lpDD4, szsurface[sno], 0, 0);
			break;

		} // end switch on which surface

		if( lpDDS[sno] == NULL )
	    {
			sprintf( tempstr, "Creating Surface %d  (%s)", sno, szsurface[sno] );
			cleanup( MISC, tempstr );
		}
		DDSetColorKey(lpDDS[sno], RGB(0,0,0));
	}


// Get the !^@%34!@ pixel format!!!

	memset(&ddpf, 0, sizeof(ddpf));
	ddpf.dwSize = sizeof(ddpf);
	if (SUCCEEDED(lpDDSPrimary->GetPixelFormat(&ddpf)))
	{
		word tempmask;	// used to determine number of bits to shift

		rmask = (word)ddpf.dwRBitMask;
		gmask = (word)ddpf.dwGBitMask;
		bmask = (word)ddpf.dwBBitMask;

		
// Get number of bits per component ... then determine bitshift for each color
// Red component ...
		tempmask = rmask;
		rnumbits = 0;

		while( tempmask )
		{
			tempmask = tempmask & (tempmask-1);
			rnumbits++;
		} // end keep going until number of bits determined

// Green component ...
		tempmask = gmask;
		gnumbits = 0;

		while( tempmask )
		{
			tempmask = tempmask & (tempmask-1);
			gnumbits++;
		} // end keep going until number of bits determined

// Blue component ...
		tempmask = bmask;
		bnumbits = 0;

		while( tempmask )
		{
			tempmask = tempmask & (tempmask-1);
			bnumbits++;
		} // end keep going until number of bits determined

		
		rbitshift = gnumbits+bnumbits;
		gbitshift = bnumbits;
		bbitshift = 0;		// just in case we have a weird format like RBG or BGR or something

		if( gnumbits == 6 )
		{
			pixelformat = PF_565;
		} // end if 565
		else if (gnumbits == 5)
		{
			pixelformat = PF_555;
		}
		else
		{
			pixelformat = PF_OTHER;
		}

	} // end if getpixelformat suceeded
	else
	{
		MessageBox( hwndmain, "GetPixelFormat Failed!", TITLE, MB_OK );
		cleanup( OK, NULL );
	}

#ifdef DEBUG
sprintf( debugstr, "Pixel Format: %d%d%d\n", rnumbits, gnumbits, bnumbits );
WriteFile( debugfh, debugstr, strlen(debugstr), &numofbytesread, NULL );
#endif

//  showpixelformat();


    return TRUE;
} /* doInit */




/*
 * WinMain - initialization, message loop
 */
int PASCAL WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance,
			LPSTR lpCmdLine, int nCmdShow)
{
//	int index;
    MSG		msg;

    lpCmdLine = lpCmdLine;
    hPrevInstance = hPrevInstance;

	BOOL Done = FALSE;



#ifdef DEBUG
		debugfh = CreateFile("debug.doc",           // create MYFILE.TXT 
             GENERIC_WRITE,                // open for writing 
             0,                            // do not share 
             NULL,                         // no security 
             CREATE_ALWAYS,                // overwrite existing 
             FILE_ATTRIBUTE_NORMAL |       // normal file 
             //FILE_FLAG_OVERLAPPED,         // asynchronous I/O 
			 NULL,
             NULL);                        // no attr. template 

		if( debugfh == INVALID_HANDLE_VALUE ) cleanup( NOFILE, "debug.doc" );

		sprintf( debugstr, "Game Start ...\n\n" );

		if( !WriteFile( debugfh, debugstr, strlen(debugstr), &numofbytesread, NULL ) ) cleanup( NOFILE, "debug.doc" );

#endif


    if( !doInit( hInstance, nCmdShow ) ) return FALSE;


// Seed random number generator ...	
	srand( (unsigned)time(NULL) );




// Set priority to highest ...
// Only if needed!
//	SetPriorityClass( GetCurrentProcess(), HIGH_PRIORITY_CLASS );



// make a global copy for use by dialog boxes ...
	hInst = hInstance;

// Remember the home directory ...
	GetCurrentDirectory( MAX_PATH+1, homedir );


// Do graphics and game specific init ...
	if( !setup() ) return FALSE;



// Setup and start timer from winmm.lib
	clockid = timeSetEvent( 1000/60, 0, mytimer, NULL, TIME_PERIODIC | TIME_CALLBACK_FUNCTION );

	if( clockid == NULL ) cleanup( MISC, "Unable to set Multimedia Timer!" );


	resetfps = 0;
	strcpy( fpsstr, "Testing ..." );


// Show Splash Screens ...
	intro();


// Setup DirectSound, and load all static sounds ...
	if( InitDSound( hwndmain, NULL ) == FALSE ) cleanup( NOSOUND, "Can't initialize DirectSound!" );

// Test Secondary streaming buffer (for music?) ...
//	if( SetupStreamBuffer( "wave\\starter1.wav" ) == FALSE ) cleanup( NOSOUND, "Unable to play wave file!" );



	for( int soundno = 1; soundno < NUMSOUNDS+1; soundno++ )
	{
sprintf( debugstr, "Loading Sound %d ... %s\n", soundno, szsoundname[soundno] );
WRITETODEBUGFILE;
		if( LoadSound( soundno, szsoundname[soundno] ) == FALSE )
		{
			cleanup( NOSOUND, "Unable to load sound!" );
		}

	} // end load all static sounds



// Initialize DirectMusic ...


if (SUCCEEDED(CoInitialize(NULL)))
{
// DirectMusic initialization and playback
	HRESULT result;


// Init Performance ...	
	g_pPerf = CreatePerformance();
	if( g_pPerf == NULL )
	{
		cleanup( NOSOUND, "CreatePerformance failed." );
	}

sprintf( debugstr, "Calling g_pPerf->Init() ...\n" );
WRITETODEBUGFILE;

	result = g_pPerf->Init( NULL, lpds, hwndmain );

sprintf( debugstr, " Returned from g_pPerf->Init().\n" );
WRITETODEBUGFILE;


	switch( result )
	{
	default:
		cleanup( NOSOUND, "Init Failed." );
		break;

	case DMUS_E_ALREADY_INITED:
		cleanup( NOSOUND, "Init Failed. (DMUS_E_ALREADY_INITED)" );
		break;

	case E_OUTOFMEMORY:
		cleanup( NOSOUND, "Init Failed. (E_OUTOFMEMORY)" );
		break;

	case E_POINTER:
		cleanup( NOSOUND, "Init Failed. (E_POINTER)" );
		break;

	case S_OK:
		break;
	} // end switch on result


sprintf( debugstr, "Calling g_pPerf->AddPort() ...\n" );
WRITETODEBUGFILE;

	if( (FAILED( g_pPerf->AddPort( NULL ) )) )
	{
		cleanup( NOSOUND, "AddPort failed." );
	}

sprintf( debugstr, " Returned from g_pPerf->AddPort().\n" );
WRITETODEBUGFILE;

// Init Loader ...
sprintf( debugstr, "Calling CreateLoader() ...\n" );
WRITETODEBUGFILE;

	g_pLoader = CreateLoader();
	if( g_pLoader == NULL )
	{
		cleanup( NOSOUND, "CreateLoader failed." );
	}
sprintf( debugstr, " Returned from CreateLoader().\n" );
WRITETODEBUGFILE;


// Init Segment ...
sprintf( debugstr, "Calling LoadSegment() ...\n" );
WRITETODEBUGFILE;

	g_pMIDISeg = LoadSegment( g_pLoader, "music\\traffic1.mid" );
	if( g_pMIDISeg == NULL )
	{
		cleanup( NOSOUND, "LoadSegment failed." );
	}

sprintf( debugstr, " Returned from LoadSegment().\n" );
WRITETODEBUGFILE;

	g_pMIDISeg->SetRepeats( 1000000 );


// 1
	g_pMIDISeg1 = LoadSegment( g_pLoader, "music\\traffic2.mid" );
	if( g_pMIDISeg1 == NULL )
	{
		cleanup( NOSOUND, "LoadSegment failed." );
	}

	g_pMIDISeg1->SetRepeats( 1000000 );


// 2
	g_pMIDISeg2 = LoadSegment( g_pLoader, "music\\traffic3.mid" );
	if( g_pMIDISeg2 == NULL )
	{
		cleanup( NOSOUND, "LoadSegment failed." );
	}

	g_pMIDISeg2->SetRepeats( 1000000 );

// 3
	g_pMIDISeg3 = LoadSegment( g_pLoader, "music\\traffic4.mid" );
	if( g_pMIDISeg3 == NULL )
	{
		cleanup( NOSOUND, "LoadSegment failed." );
	}

	g_pMIDISeg3->SetRepeats( 1000000 );



// Credits
	g_pMIDISegCredits = LoadSegment( g_pLoader, "music\\credits.mid" );
	if( g_pMIDISegCredits == NULL )
	{
		cleanup( NOSOUND, "LoadSegment failed." );
	}

	g_pMIDISegCredits->SetRepeats( 1000000 );

}  // Else terminate the application
else
{
	cleanup( NOSOUND, "Unable to init COM." );
} // if couldn't init COM



// Start Game here ...


// TODO -- Put this back in ?!?!?
//	startgamescreen( GS_MAINMENU );
	gamescreen = GS_MAINMENU;
	setcursormode( MENUCURSOR );




sprintf( debugstr, "Entering main loop ...\n" );
WRITETODEBUGFILE;

/*

  Main Loop ...

*/
	refreshscreen();

	if( g_pPerf ) g_pPerf->PlaySegment( g_pMIDISeg, 0, 0, &g_pSegState );




    while( !Done )
    {         
		if( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) )
		{
			if( !GetMessage( &msg, NULL, 0, 0 ) )
			{
				Done = TRUE;
			} // end if WM_QUIT received
		TranslateMessage(&msg); 
		DispatchMessage(&msg);
		}

		else if( bActive && fullscreen )
		{
			displayscreen();
		} // end if bActive
		else
		{
			// make sure we go to sleep if we have nothing else to do
			WaitMessage();
		} // end if NOT bActive

    }  // end main loop


	finiObjects();
	return msg.wParam;


// For Streaming Sound Buffer ...
/*
while (!Done)
{
    DWORD dwEvt = MsgWaitForMultipleObjects(
            NUMEVENTS,      // How many possible events
            rghEvent,       // Location of handles
            FALSE,          // Wait for all?
            INFINITE,       // How long to wait
            QS_ALLINPUT);   // Any message is an event
 
    // WAIT_OBJECT_0 == 0 but is properly treated as an arbitrary
    // index value assigned to the first event, therefore we subtract
    // it from dwEvt to get the zero-based index of the event.
 
    dwEvt -= WAIT_OBJECT_0;
 
    // If the event was set by the buffer, there's input
    // to process. 
 
    if (dwEvt < NUMEVENTS) 
    {
        StreamToBuffer(dwEvt); // copy data to output stream
    }
 
    // If it's the last event, it's a message 
 
    else if (dwEvt == NUMEVENTS) 
    {         
		if( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) )
		{
			if( !GetMessage( &msg, NULL, 0, 0 ) )
			{
				Done = TRUE;
			} // end if WM_QUIT received
		TranslateMessage(&msg); 
		DispatchMessage(&msg);
		}
    }  // end message processing


	if( bActive )
	{
		displayscreen();
	} // end if bActive
	else
	{
		// make sure we go to sleep if we have nothing else to do
		WaitMessage();
	} // end if NOT bActive


} // while (!Done)

*/

} // end WinMain



void CALLBACK mytimer(UINT uID, UINT uMsg, DWORD dwUser, DWORD dw1, DWORD dw2)
{
		tickcount++;	// Is this accurate enough ?
		frametickcount++;
		resetfps++;

		if( !gamepaused ) lighttickcount++;

		if( cursoranimated )
		{
			if( cursortickcount == tickcount )
			{
				if( ++cursorframe == 8 ) cursorframe = 0;
				cursortickcount = tickcount + CURSORANIMSPEED;
			} // end if time to change cursorframe
		} // end if cursoranimated

		tickgoneby = 1;

} // end mytimer






void waitfor( int numticks )
{
	dword newclock;


	newclock = tickcount + numticks;

	while( tickcount < newclock ) {};

} // end waitfor

