/*
menu.cpp
menu functions ...

Copyright (C) 1995-2005  Everett Bell

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include "globals.h"




byte pushgamescreen( byte gs )
{
	int index;


	if( gamescreenstack[31] != 0 )
	{
		lpDD4->FlipToGDISurface();
		MessageBox( hwndmain, "Game Screen Stack Full!", "Error", MB_OK );
		return 0;
	} // end if stack full

// Shift all current gamescreens up the stack up by one ...
	for( index = 31; index > 0; index-- )
	{
		gamescreenstack[index] = gamescreenstack[index-1];
	} // end index loop

	gamescreenstack[0] = gs;


	return TRUE;

} // end pushgamescreen


byte popgamescreen( void )
{
	int index;
	byte gs;


	gs = gamescreenstack[0];

	if( gs == 0 )
	{
		lpDD4->FlipToGDISurface();
		MessageBox( hwndmain, "No Game Screens on Stack!", "Error", MB_OK );
		return 0;
	} // end if none on stack 

	for( index = 0; index < 31; index++ )
	{
		gamescreenstack[index] = gamescreenstack[index+1];

	} // end index loop

	gamescreenstack[31] = 0;


// Can I set the cursormode here ?
	switch( gs )
	{
	case GS_MAINMENU:
	case GS_OKBOX:
	case GS_CREDITS:
	case GS_CHOOSEFILE:
	case GS_CONFIRM:
		setcursormode( MENUCURSOR );
		editmode = 0;
		break;

	case GS_SELECTLIST:
		setcursormode( MENUCURSOR );
		editmode = 1;
		break;

	} // end switch on which screen are we popping back into ...

// I'm doing this so the WM_BUTTONUP message is not sent when changing screens ...
	waitingforlmbup = 1;
	
	return gs;

} // end popgamescreen