/*
message.cpp
message handler ...

Copyright (C) 1995-2005  Everett Bell

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include "globals.h"

#include "commdlg.h"



// For main menu light changing ...

#define LM_OFF		0
#define LM_RED		1
#define LM_YELLOW	2
#define LM_GREEN	3

byte lightmode = LM_OFF;
byte lightchanged = 0;

int bmphomex[4] = { 0, 40, 40, 40 };
int bmphomey[4] = { 0, 200, 252, 316 };

#define BMPHEIGHT	192
#define BMPWIDTH	480

byte oldlightmode;
HRESULT ddrval;
RECT rcRect;






long FAR PASCAL WindowProc( HWND hWnd, UINT message, 
			    WPARAM wParam, LPARAM lParam )
{
//	int index;
	byte ctrlkeydown = 0;


// This handles ALL messages that come through no matter which part of the game the player is in ...

	switch( message )
    {
// I'm gonna try to use this to know when i can restore my surfaces ...	
// Doesn't work if current user settings == game settings !

	case WM_DISPLAYCHANGE:
/*
		if( (LOWORD(lParam) == SCREENWIDTH) && (HIWORD(lParam) == SCREENHEIGHT) && (wParam == COLORDEPTH) )
		{
			fullscreen = 1;
		}
		else
		{
			fullscreen = 0;
		}
*/

#ifdef DEBUG
sprintf( debugstr, "WM_DISPLAYCHANGE received ... fullscreen: %d, tickcount: 0x%.8x\n", fullscreen, tickcount );
WRITETODEBUGFILE;
#endif
		break; // end WM_DISPLAYCHANGE


/*
	case WM_ACTIVATE:
		switch( LOWORD(wParam) )
		{
		case WA_ACTIVE:
		case WA_CLICKACTIVE:
//			bActive = 1;
//			SetPriorityClass( GetCurrentProcess(), HIGH_PRIORITY_CLASS );
			break;

		case WA_INACTIVE:
//			bActive = 0;
//			SetPriorityClass( GetCurrentProcess(), NORMAL_PRIORITY_CLASS );
			break;

		} // end switch on activate on disactivate

#ifdef DEBUG
sprintf( debugstr, "WM_ACTIVATE received ... fullscreen: %d, bActive: %d, tickcount: 0x%.8x\n", fullscreen, bActive, tickcount );
WRITETODEBUGFILE;
#endif

		break;
*/



// Is this still needed ?
    case WM_ACTIVATEAPP:
    	bActive = wParam;

#ifdef DEBUG
sprintf( debugstr, "WM_ACTIVATEAPP received ... bActive: %d, tickcount: 0x%.8x\n", bActive, tickcount );
WRITETODEBUGFILE;
#endif
		if( bActive && fullscreen )
		{
			restoreAll();

// To cover unknown areas ...			
			clearscreen();

// Images not drawn by refreshscreen() ...
			switch( gamescreen )
			{
			case GS_CHOOSEFILE:
				showbitmap( "bitmaps\\mainmenu.bmp", 0, 0 );
				break; // end GS_CHOOSEFILE

			case GS_OKBOX:
//				showspriteonce( "bitmaps\\textbox.bmp", (SCREENWIDTH/2)-200, 230 );
				showbitmap( "bitmaps\\textbox.bmp", (SCREENWIDTH/2)-200, 230 );

//		SETTEXTCOLOR(30,24,16);
		        myfont = EURO;
				centertext( okboxtext, 260, 0, SCREENWIDTH );

		        drawbutton( 0 );

				break; // end GS_OKBOX

			case GS_CONFIRM:
//				showspriteonce( "bitmaps\\textbox.bmp", (SCREENWIDTH/2)-200, 230 );
				showbitmap( "bitmaps\\textbox.bmp", (SCREENWIDTH/2)-200, 230 );

//		SETTEXTCOLOR(30,24,16);
		        myfont = EURO;
				centertext( okboxtext, 260, 0, SCREENWIDTH );

		        drawbutton( 0 );
				drawbutton( 1 );

				break; // end GS_CONFIRM

			} // end switch on gamescreen ...

			refreshscreen();
		} // end if app just activated ... restore all surfaces and refreshscreen

		break;



    case WM_SETCURSOR:
        SetCursor(NULL);
        return TRUE;


    case WM_CREATE:
		break;


    case WM_KEYDOWN:
// Determine if ctrlkeydown ... I use this to keep a WM_KEYDOWN message being sent to the gamescreen handlers
// if it is down ...
		if( GetKeyState(VK_CONTROL)&0xFF00 ) ctrlkeydown = 1;

		switch( wParam )
		{
//			case VK_ESCAPE:
//				PostMessage(hWnd, WM_CLOSE, 0, 0);
//				break;
			case VK_F1:
				if( !ctrlkeydown ) break;
				switch( languageoffset )
				{
				case ENGLISH:
					languageoffset = GERMAN; break;
				case GERMAN:
					languageoffset = ENGLISH; break;
//				case SPANISH:
//					languageoffset = FRENCH; break;
//				case FRENCH:
//					languageoffset = ENGLISH; break;
				} // end switch on current language;

				refreshscreen();
				break;

#ifdef EDITORS

			case VK_F11:
				fpson ^= 1;
				break;

			case VK_F12:
				screenshot();
				break;


			case VK_DELETE:
				if( !ctrlkeydown ) break;

				systemmessage( "Screen Cleared!" );
				
				LOCKVS;
				ZeroMemory( g_vsptr, VSCREENHEIGHT * VSCREENWIDTH * (COLORDEPTH/8) );
				UNLOCKVS;
				break;

			case 'R':
				if( !ctrlkeydown ) break;
				refreshscreen();
				break;

			case 'M':
				difficulty++;
				if( difficulty == 41 ) difficulty = 40;
				break;
			case 'N':
				difficulty--;
				if( difficulty == 0 ) difficulty = 1;
				break;

			case VK_F9:
				rollcredits();
				break;


#endif

		} // end switch on key

		break;



	case WM_MOUSEMOVE:
		LPPOINT lpPoint;	// For retrieving cursor position ...
		POINT point;

		lpPoint = &point;


		GetCursorPos( lpPoint );

		cursorx = lpPoint->x;
		cursory = lpPoint->y;

		break;


	case WM_LBUTTONDOWN:
		lmb = 1;
		break;
	case WM_RBUTTONDOWN:
		rmb = 1;
		break;
	case WM_LBUTTONUP:
		lmb = 0;
		break;
	case WM_RBUTTONUP:
		rmb = 0;
		break;



    case WM_DESTROY:
		SetPriorityClass( GetCurrentProcess(), NORMAL_PRIORITY_CLASS );

		if( timeKillEvent(clockid) == MMSYSERR_INVALPARAM )
		{
			sprintf( tempstr, "clockid = %d", clockid );
			MessageBox( hwndmain, tempstr, "Could Not Kill Timer!", MB_OK );
		} // end if Kill timer failed


		finiObjects();
		PostQuitMessage( 0 );
//		CloseHandle( debugfh );
		break;

    } // end switch on Windows Message

// Now dispatch the message out to the appropriate game screen if it is NOT a CTRL key combination ...

// If control key is pressed, do NOT send WM_KEYDOWN through to appropriate game screen handler!
	if( (message == WM_KEYDOWN) && ctrlkeydown )
	 return DefWindowProc(hWnd, message, wParam, lParam);


	switch( gamescreen )
	{
	case GS_MAINMENU:
		mainmenumessagehandler( message, wParam, lParam );
		break;
	case GS_OKBOX:
		okboxmessagehandler( message, wParam, lParam );
		break;
	case GS_WAITFORINPUT:
		waitmessagehandler( message, wParam, lParam );
		break;
	case GS_CREDITS:
		creditsmessagehandler( message, wParam, lParam );
		break;
	case GS_CHOOSEFILE:
		choosefilemessagehandler( message, wParam, lParam );
		break;
	case GS_CONFIRM:
		confirmmessagehandler( message, wParam, lParam );
		break;
	case GS_SELECTLIST:
		selectlistmessagehandler( message, wParam, lParam );
		break;

	case GS_EDITMAP:
		editmapmessagehandler( message, wParam, lParam );
		break;
	case GS_GAME:
		gamemessagehandler( message, wParam, lParam );
		break;

	case GS_MAKEPATH:
		makepathmessagehandler( message, wParam, lParam );
		break;
	} // end switch on gamescreen
	

    return DefWindowProc(hWnd, message, wParam, lParam);

} // end WindowProc






int mainmenumessagehandler( UINT message, WPARAM wParam, LPARAM lParam )
{
//	int index;
//	int buttonno;

	int index;
	int result;
	OPENFILENAME ofn;

	char tempfilename[MAX_PATH+1];


	switch( message )
	{
	case WM_KEYDOWN:
		switch( wParam )
		{
		case VK_ESCAPE:
			if( confirm( "EXIT THE GAME?" )	)
			{
#ifdef SHAREWARE
				showorderinfo();
#endif

				cleanup( OK, NULL );
			}
			break;

//		case VK_F2:
//			if( gamescreen != GS_GAME ) rungame();
//			break;

#ifdef EDITORS
		case VK_F3:
			if( gamescreen != GS_EDITMAP )
			{
				editmap();
			}
			break;


		case VK_F5:
			lpdsbuffer[SND_1]->Play( NULL, NULL, NULL );
			break;
		case VK_F6:
			lpdsbuffer[SND_2]->Play( NULL, NULL, NULL );
			break;
		case VK_F7:
			lpdsbuffer[SND_3]->Play( NULL, NULL, NULL );
			break;
		case VK_F8:
			lpdsbuffer[SND_4]->Play( NULL, NULL, NULL );
			break;

		case 'C':
			for( campcityno = 0; campcityno < 5; campcityno++ )
			{
				if( choosefile( CITYFILE ) == FALSE )
				{
					break;
				} // end if cancelled

				strcpy( szcampcityname[campcityno], filename );
			} // end pick 5 cities ...

			if( campcityno != 5 ) break; // if cancelled

// Save Campaign File ...

				ZeroMemory( &ofn, sizeof(OPENFILENAME) );

				ofn.lStructSize = sizeof( OPENFILENAME );
				ofn.hwndOwner = hwndmain;
				strcpy( tempfilename, "*.cmp" );
				ofn.lpstrFile = tempfilename;
				ofn.nMaxFile = MAX_PATH+1;
				ofn.lpstrInitialDir = "Campaigns";
				ofn.Flags = OFN_NOCHANGEDIR;
				ofn.lpstrDefExt = "cmp";
				ofn.lpstrTitle = "Save As ...";

				lpDD4->FlipToGDISurface();

				result = GetSaveFileName( &ofn );

				if( result == 0 ) break; // end if user cancelled ...

				strcpy( filename, ofn.lpstrFile );


				filehandle = CreateFile( filename,           // create MYFILE.TXT 
				     GENERIC_WRITE,                // open for writing 
					0,                            // do not share 
					NULL,                         // no security 
					CREATE_ALWAYS,                // overwrite existing 
					FILE_ATTRIBUTE_NORMAL |       // normal file 
					FILE_FLAG_OVERLAPPED,         // asynchronous I/O 
					NULL);                        // no attr. template 

				if( filehandle == INVALID_HANDLE_VALUE ) cleanup( NOFILE, filename );

				WriteFile( filehandle, szcampcityname[0], MAX_PATH+1, &numofbytesread, NULL );
				WriteFile( filehandle, szcampcityname[1], MAX_PATH+1, &numofbytesread, NULL );
				WriteFile( filehandle, szcampcityname[2], MAX_PATH+1, &numofbytesread, NULL );
				WriteFile( filehandle, szcampcityname[3], MAX_PATH+1, &numofbytesread, NULL );
				WriteFile( filehandle, szcampcityname[4], MAX_PATH+1, &numofbytesread, NULL );

				CloseHandle( filehandle );


			break; // end case 'C' ... create campaign

#endif


		} // end switch on WHICH key got pressed

		break; // end WM_KEYDOWN

	case WM_MOUSEMOVE:
		oldlightmode = lightmode;

		for( index = 1; index < 4; index++ )
		{
			if( (cursorx > bmphomex[index]) && (cursorx < bmphomex[index]+BMPWIDTH) &&
				(cursory > bmphomey[index]) && (cursory < bmphomey[index] + 65) )
			{
				lightmode = index;
				break;
			} // end if over option
		} // end see if over option ...

		if( index == 4 ) lightmode = 0;

		if( lightmode != oldlightmode )
		{
if( soundon && lightmode ) lpdsbuffer[SND_CLICK]->Play( NULL, NULL, NULL );

// Blt new image ...
	rcRect.left = 0;
	rcRect.top = 0;
	rcRect.right = BMPWIDTH;
	rcRect.bottom = 200+BMPHEIGHT;


    while( 1 )
    {
        ddrval = lpDDSVS->BltFast( bmphomex[1], bmphomey[1], lpDDS[DDS_MMNOLIGHT+lightmode],
            0, DDBLTFAST_NOCOLORKEY );
//        ddrval = lpDDSBack->Blt( &rcRect2, lpDDS[CURSORS],
//            &rcRect, DDBLT_KEYSRC, NULL );

		if( ddrval == DD_OK ) break;
		if( ddrval == DDERR_SURFACELOST )
		{
			ddrval = restoreAll();
			if( ddrval != DD_OK )
			{
				ShowDDError( "restoreAll()", ddrval );
				cleanup( OK, NULL );
			}
			refreshscreen();
			continue;
/*
			ddrval = DDReLoadBitmap( lpDDS[DDS_MMNOLIGHT+lightmode], szsurface[DDS_MMNOLIGHT+lightmode] );
			if( ddrval != DD_OK )
			{
				ShowDDError( "DDReLoadBitmap() when updating light image ...", ddrval );
				cleanup(OK, NULL );
			} 
*/
		}
		if( ddrval != DDERR_WASSTILLDRAWING )
		{
			ShowDDError( "BltFast() when updating image ...", ddrval );
			cleanup( OK, NULL );
		}

	} // end loop

    if(ddrval != DD_OK)
	{
		ShowDDError( "BltFast() when updating image2 ...", ddrval );
		cleanup( OK, NULL );
	}

		} // end if changed since last mousemove

		break; // end WM_MOUSEMOVE


	case WM_LBUTTONDOWN:
		switch( lightmode )
		{
		default:
			break;

		case LM_RED:
if( soundon ) lpdsbuffer[SND_CLICK]->Play( NULL, NULL, NULL );
			if( confirm( "EXIT THE GAME?" )	)
			{
#ifdef SHAREWARE
				showorderinfo();
#endif

				cleanup( OK, NULL );
			}
			break;

		case LM_YELLOW:
if( soundon ) lpdsbuffer[SND_CLICK]->Play( NULL, NULL, NULL );
			playingcampaign = FALSE;

			rungame();

			refreshscreen();
			break;

		case LM_GREEN:
if( soundon ) lpdsbuffer[SND_CLICK]->Play( NULL, NULL, NULL );


#ifdef SHAREWARE
			okbox( "Only Available in Full Version" );
			break;
#endif


// Choose Campaign ...
			if( choosefile( CAMPFILE ) == FALSE ) break;

// Read Campaign File ...
	filehandle = CreateFile( filename,           // open MYFILE.TXT 
                GENERIC_READ,              // open for reading 
                FILE_SHARE_READ,           // share for reading 
                NULL,                      // no security 
                OPEN_EXISTING,             // existing file only 
                FILE_ATTRIBUTE_NORMAL,     // normal file 
                NULL);                     // no attr. template 

	if( filehandle == INVALID_HANDLE_VALUE ) cleanup( NOFILE, filename );

	ReadFile( filehandle, szcampcityname[0], MAX_PATH+1, &numofbytesread, NULL );
	ReadFile( filehandle, szcampcityname[1], MAX_PATH+1, &numofbytesread, NULL );
	ReadFile( filehandle, szcampcityname[2], MAX_PATH+1, &numofbytesread, NULL );
	ReadFile( filehandle, szcampcityname[3], MAX_PATH+1, &numofbytesread, NULL );
	ReadFile( filehandle, szcampcityname[4], MAX_PATH+1, &numofbytesread, NULL );

	hiscore = 0; // in case ReadFile() fails ...
	ReadFile( filehandle, &hiscore, sizeof(hiscore), &numofbytesread, NULL );


	CloseHandle( filehandle );


			playingcampaign = TRUE;
			campcityno = 0; // Start at first city ...

			rungame();

			refreshscreen();

			playingcampaign = FALSE;
			break;
		} // end switch on lightmode

		break; // end WM_LBUTTONDOWN


	} // end switch on Windows Messages for GS_MAINMENU

	return TRUE;
} // end mainmenumessagehandler




int okboxmessagehandler( UINT message, WPARAM wParam, LPARAM lParam )
{
	int buttonno;


	switch( message )
	{
	case WM_KEYDOWN:
		switch( wParam )
		{
		case VK_RETURN:
		case VK_ESCAPE:
			button[0].pushed = 1;
			drawbutton( 0 );
			displayscreen();

			g_response = TRUE;

if( soundon ) lpdsbuffer[SND_CLICK]->Play( NULL, NULL, NULL );

			break;

		} // end switch on WHICH key got pressed

		break; // end WM_KEYDOWN



	case WM_LBUTTONDOWN:
		if( (cursorx>button[0].x1) && (cursorx<button[0].x1+button[0].width) &&
			(cursory>button[0].y1) && (cursory<button[0].y1+32) )
		{
			button[0].pushed = 1;
			drawbutton( 0 );
			displayscreen();

			g_response = TRUE;
if( soundon ) lpdsbuffer[SND_CLICK]->Play( NULL, NULL, NULL );

			break;
		} // end if pressed on "Ok" button

		break;

	case WM_MOUSEMOVE:
		for( buttonno = 0; buttonno < 1; buttonno++ )
		{
			if( (cursorx>button[buttonno].x1) && (cursorx<button[buttonno].x1+button[buttonno].width) &&
				(cursory>button[buttonno].y1) && (cursory<button[buttonno].y1+32) )
			{
				button[buttonno].glowing = 1;
			} // end if cursor on top of button
			else button[buttonno].glowing = 0;

			drawbutton( buttonno );
		} // end buttonno loop
		break; // end WM_MOUSEMOVE

	} // end switch on Windows Messages for GS_OKBOX


	return TRUE;

} // end okboxmessagehandler



int confirmmessagehandler( UINT message, WPARAM wParam, LPARAM lParam )
{
	int buttonno;


	switch( message )
	{
	case WM_KEYDOWN:
		switch( wParam )
		{
		case VK_ESCAPE:
			button[0].pushed = 1;
			drawbutton( 0 );
			displayscreen();

			g_response = FALSE;

			break;

		case VK_RETURN:
		case 'Y':
			button[1].pushed = 1;
			drawbutton( 1 );
			displayscreen();

			g_response = TRUE;

			break;

		case 'N':
			button[0].pushed = 1;
			drawbutton( 0 );
			displayscreen();

			g_response = FALSE;

			break;

		} // end switch on WHICH key got pressed

if( soundon ) lpdsbuffer[SND_CLICK]->Play( NULL, NULL, NULL );

		break; // end WM_KEYDOWN

	case WM_LBUTTONDOWN:
		if( (cursorx>button[0].x1) && (cursorx<button[0].x1+button[0].width) &&
			(cursory>button[0].y1) && (cursory<button[0].y1+32) )
		{
			button[0].pushed = 1;
			drawbutton( 0 );
			displayscreen();

			g_response = FALSE;

if( soundon ) lpdsbuffer[SND_CLICK]->Play( NULL, NULL, NULL );

			break;
		} // end if pressed on "No" button

		if( (cursorx>button[1].x1) && (cursorx<button[1].x1+button[1].width) &&
			(cursory>button[1].y1) && (cursory<button[1].y1+32) )
		{
			button[1].pushed = 1;
			drawbutton( 1 );
			displayscreen();

			g_response = TRUE;

if( soundon ) lpdsbuffer[SND_CLICK]->Play( NULL, NULL, NULL );

			break;
		} // end if pressed on "No" button

		break;

	case WM_MOUSEMOVE:
		for( buttonno = 0; buttonno < 2; buttonno++ )
		{
			if( (cursorx>button[buttonno].x1) && (cursorx<button[buttonno].x1+button[buttonno].width) &&
				(cursory>button[buttonno].y1) && (cursory<button[buttonno].y1+32) )
			{
				button[buttonno].glowing = 1;
			} // end if cursor on top of button
			else button[buttonno].glowing = 0;

			drawbutton( buttonno );
		} // end buttonno loop
		break; // end WM_MOUSEMOVE

	} // end switch on Windows Messages for GS_CONFIRM


	return TRUE;

} // end confirmmessagehandler



int waitmessagehandler( UINT message, WPARAM wParam, LPARAM lParam )
{

	switch( message )
	{
	case WM_KEYDOWN:
		g_response = TRUE;

		break; // end WM_KEYDOWN

	case WM_RBUTTONDOWN:	
	case WM_LBUTTONDOWN:
		g_response = TRUE;
		break;

	} // end switch on Windows Messages for GS_WAITFORINPUT


	return TRUE;

} // end waitmessagehandler








// Called after gamescreen changes, or to refresh the screen user is on ...
BOOL refreshscreen( void )
{
//	int tempx, tempy;	// For Editors ...
	int listx, listy, index;

	HRESULT ddrval;
	RECT rcRect;



	switch( gamescreen )
	{
	case GS_CREDITS:
		clearscreen();
		showbitmap( "bitmaps\\nsplogo.bmp", (SCREENWIDTH/2)-160, SCREENHEIGHT-240 );
		break;



	case GS_EDITMAP:
	case GS_MAKEPATH:
	case GS_GAME:
		drawinterface();
		drawcitymap();
		break; // end GS_GAME

	case GS_MAINMENU:
		showbitmap( "bitmaps\\mainmenu.bmp", 0, 0 );

		for( index = 1; index < 4; index++ )
		{
			if( (cursorx > bmphomex[index]) && (cursorx < bmphomex[index]+BMPWIDTH) &&
				(cursory > bmphomey[index]) && (cursory < bmphomey[index] + 65) )
			{
				lightmode = index;
				break;
			} // end if over option
		} // end see if over option ...

		if( index == 4 ) lightmode = 0;

// Blt new image ...
	rcRect.left = 0;
	rcRect.top = 0;
	rcRect.right = BMPWIDTH;
	rcRect.bottom = 200+BMPHEIGHT;


    while( 1 )
    {
        ddrval = lpDDSVS->BltFast( bmphomex[1], bmphomey[1], lpDDS[DDS_MMNOLIGHT+lightmode],
            0, DDBLTFAST_NOCOLORKEY );
//        ddrval = lpDDSBack->Blt( &rcRect2, lpDDS[CURSORS],
//            &rcRect, DDBLT_KEYSRC, NULL );

		if( ddrval == DD_OK ) break;
		if( ddrval == DDERR_SURFACELOST )
		{
			ddrval = restoreAll();
			if( ddrval != DD_OK )
			{
				ShowDDError( "restoreAll()", ddrval );
				cleanup( OK, NULL );
			}
			continue;
/*
			ddrval = DDReLoadBitmap( lpDDS[DDS_MMNOLIGHT+lightmode], szsurface[DDS_MMNOLIGHT+lightmode] );
			if( ddrval != DD_OK )
			{
				ShowDDError( "DDReLoadBitmap() when updating light image ...", ddrval );
				cleanup(OK, NULL );
			} 
*/
		}
		if( ddrval != DDERR_WASSTILLDRAWING )
		{
			ShowDDError( "BltFast() when updating image ...", ddrval );
			cleanup( OK, NULL );
		}

	} // end loop

    if(ddrval != DD_OK)
	{
		ShowDDError( "BltFast() when updating image2 ...", ddrval );
		cleanup( OK, NULL );
	}


		sprintf( tempstr, "ver %.2f", versionno );

#ifdef SHAREWARE
		sprintf( tempstr, "shareware ver %.2f", versionno );
#endif

		myfont = EURO;
		showtextjr( tempstr, 800-8, 600-26 );


		break;	// end GS_MAINMENU


	case GS_SELECTLIST:
		int lineindex;
		int optionno;
		int listheight;
		word *tempscreenptr;
		int tempx, tempy;

		listheight = numoptions * 14;
		tempx = listboxx+4;
		tempy = listboxy+2;

		textinbounds = 0;

		LOCKVS;

		tempscreenptr = g_vsptr + VSOFFSET + listboxx + times800(listboxy);

		for( optionno = 0; optionno < numoptions; optionno++ )
		{
			if( optionno == selectedoption-1 ) // Convert to 1-? instead of 0-?
			{
				for( lineindex = 0; lineindex < 14; lineindex++ )
				{
					memset( tempscreenptr, 2, listwidth );
					tempscreenptr += VSCREENWIDTH;
				} // end lineindex loop

//				SETTEXTCOLOR(31,31,31);
				showtext( selectoption[optionno].text, tempx, tempy );
			} // end if drawing selectedoption
			else
			{
				for( lineindex = 0; lineindex < 14; lineindex++ )
				{
					memset( tempscreenptr, 1, listwidth );
					tempscreenptr += VSCREENWIDTH;
				} // end lineindex loop

//				if( selectoption[optionno].disabled ) SETTEXTCOLOR(12,12,12)
//				else SETTEXTCOLOR(0,24,0);

				showtext( selectoption[optionno].text, tempx, tempy );
			} // end if NOT selectedoption

			tempy += 14;

		} // end optionno loop

		UNLOCKVS;

		textinbounds = 1;

		break; // end GS_SELECTLIST

	case GS_CHOOSEFILE:
//	showspriteonce( "bitmaps\\chooseinterface.bmp", 200, 50 );
	rcRect.left = 0;
	rcRect.top = 0;
	rcRect.right = 400;
	rcRect.bottom = 500;

    while( 1 )
    {
        ddrval = lpDDSVS->BltFast( 200, 50, lpDDS[DDS_CHOOSEINTERFACE],
            &rcRect, DDBLTFAST_NOCOLORKEY );
//        ddrval = lpDDSBack->Blt( &rcRect2, lpDDS[CURSORS],
//            &rcRect, DDBLT_KEYSRC, NULL );

		if( ddrval == DD_OK ) break;
		if( ddrval == DDERR_SURFACELOST )
		{
			ddrval = restoreAll();
			if( ddrval != DD_OK )
			{
				ShowDDError( "restoreAll()", ddrval );
				cleanup( MISC, "restoreAll()" );
			}
			continue;

		}
		if( ddrval != DDERR_WASSTILLDRAWING )
		{
			ShowDDError( "BltFast() in drawing interface", ddrval );
			cleanup( MISC, "BltFast() in drawing interface" );
		}

	} // end loop

    if(ddrval != DD_OK)
	{
		ShowDDError( "BltFast()", ddrval );
		cleanup( MISC, "BltFast()" );
	}



// Change to current location ...
	showbitmap( "bitmaps\\scrollbutton.bmp", 570, 136 + scrollypos );


//		SETTEXTCOLOR(30,24,16);
    myfont = EURO;
    centertext( okboxtext, 70, 0, SCREENWIDTH );

	LoadString( hInst, languageoffset+IDS_CANCEL, string, 256 );
	strcpy( button[0].name, string );

    button[0].x1 = 494;
    button[0].y1 = 504;
    button[0].width = 92;
    button[0].pushed = 0;
//        button[0].color = RGB16(30,24,16);
    button[0].function = BUTTONRETURN;
    button[0].variable = 0;
    button[0].memptr = NULL;
    button[0].glowing = 0;
    button[0].offset = 120;


    drawbutton( 0 );


// List all files ...
	listx = 224;
	listy = 122;

	myfont = EURODARK;


	for( index = 0; index < numfilesinlist; index++ )
	{
		if( index == 12 ) break;
		showtext( filelist[index + homefileno], listx, listy );
		listy += 30;
	} // end list all files

		break; // end GS_CHOOSEFILE

	} // end switch on gamescreen


	return TRUE;
} // end refreshscreen



int startgamescreen( byte gs )
{


	pushgamescreen( gamescreen );
	gamescreen = gs;

	switch( gamescreen )
	{
	case GS_MAINMENU:
		break;
	} // end switch on gamescreen


	refreshscreen();


	return TRUE;

} // end startgamescreen


